unit	PltDR;

interface

uses	Objects, Views, Drivers, PltDB, DataServ, Dialogs, MsgBox, App,
		PltCMD, PltVE, Editors, CharLog, PrintMas, Number, Cdecl, Grid, Dark;

type

	PPltList = ^TPltList;
	TPltList = Object (TListViewer)
		Base		: PPltCollection;
		ViewAt		: TPltSorted;
		constructor Init (Var R : TRect; VS : PScrollBar; APlt : PPltCollection);
		function	GetText (Item, MaxLen : Integer) : String; virtual;
		procedure	SelectItem (Item : Integer); virtual;
		function	IsSelected (Item : Integer) : Boolean; virtual;
		procedure	Draw; virtual;
	end;

	PPltStat = ^TPltStat;
	TPltStat = Object (TView)
		The			: PPltList;
		constructor Init (Var R : TRect; AThe : PPltList);
		procedure	SetState (AState : Word; Enable : Boolean); virtual;
		procedure	Draw; virtual;
	end;

	PPltWork = ^TPltWork;
	TPltWork = Object (TDialog)
		Base		: PPltCollection;
		Ind			: PPltStat;
		List		: PPltList;
		Stat		: PPltStat;
		FileName	: PString;
		Stream		: TBufStream;
		constructor Init (AFileName : String);
		function	Valid (Command : Word) : Boolean; virtual;
		function	Save : Boolean;
		procedure	SetState (AState : Word; Enable : Boolean); virtual;
		procedure	HandleEvent (Var Event : TEvent); virtual;
		procedure	UpDateCommand;
		destructor	Done; virtual;
	end;

	TCmen = Object (TObject)
		Code		: PInputNumber;
		CodeX		: PInputNumber;
		MFO			: PInputNumber;
		Schet		: PInputNumber;
		Name		: PMemo;
		BankN		: PInputLine;
		BankC		: PInputLine;
		constructor Init (X, Y : Integer; Var By : TGroup; As : Boolean);
		function	GetData (Var D : TFData) : Boolean;
		procedure	SetData (Var D : TFData);
	end;

	PForm = ^TForm;
	TForm = Object (TDialog)
		Summa		: PSummaInput;
		Date		: PDateView;
		Sour		: TCmen;
		Dest		: TCmen;
		Memo		: PMemo;
		constructor Init (ATitle : String; ANum : Longint);
		procedure	SetData (Var R); virtual;
		procedure	GetData (Var R); virtual;
		procedure	HandleEvent (Var Event : TEvent); virtual;
	end;

implementation

{**************************************************************** Routines **}
const

	Skey		: Longint = $35DAEC72;
	Sign		: String [27] = 'PLT ᯨ᮪ ⥦ 祭';

	PrintSetup	: TPrintSetup =
			(
				Quality : 1;
				Frames	: 1;
				Count	: 1;
				Left	: 6;
				Length	: 132;
				Page	: 56;
				Top		: 2;
				Bottom	: 2
			);

{************************************************************** TPltDialog **}
constructor TPltWork.Init (AFileName : String);
	var
		R	: TRect;
		P	: PSoftGrid;
		VS	: PScrollBar;
		N, Y: PButton;

		procedure Ad (V : PButton);
			const
				I : Byte = 0;
			begin
				with V^ do
				begin
					GrowMode := gfGrowHiY or gfGrowLoY;
					case I of
						1	: Options := Options or ofCenterX;
						2	: GrowMode := GrowMode or gfGrowHiX or gfGrowLoX;
					end;
				end;
				I := (I + 1) mod 3;
				Insert (V);
				Y := N;
				N := V;
			end;
	begin
		R.Assign (0, 0, 40, 22);
		TDialog.Init (R, AFileName);
		Flags := wfZoom or wfClose or wfMove or wfGrow or wfWinTitle;
		Options := Options or ofCentered;
		Number := DeskTop^.WinNum;
		FileName := GenStr (@AFileName);
		Stream.Init (AFileName, stOpen, 2048);
		if Stream.Status <> stOk then
			if MessageBox (#3'  䠩 ~%s~  ,'+
						#13+
						#13+
						#3'  ?', @FileName, mfConfirmation or mfYesNoCancel) = cmYes then
				begin
				Stream.Init (AFileName, stCreate, 2048);
				if Stream.Status <> stOk then
					begin
						MessageBox (#3'  ᮧ 䠩 ~%s~.', @FileName, mfError + mfCancelButton);
						Exit;
					end;
				Stream.WriteSignature (Skey);
				New (Base, Init);
				Base^.Store (Stream);
				Stream.Flush;
				end
			else
				Exit
		else
			if Stream.ReadSignature (Skey) then New (Base, Load (Stream));
		R.Assign (2, 17, 14, 19);
		Ad (New (PButton, Init (R, '&', cmSave, bfNormal)));
		R.Move (12, 0);
		Ad (New (PButton, Init (R, cEdtStr, cmEdit, bfDefault)));
		R.Move (12, 0);
		Ad (New (PButton, Init (R, cNewStr, cmNew, bfNormal)));
		R.Move (-24, 2);
		Ad (New (PButton, Init (R, cDelStr, cmDel, bfNormal)));
		R.Move (12, 0);
		Ad (New (PButton, Init (R, '&', cmPrint, bfNormal)));
		R.Move (12, 0);
		Ad (New (PButton, Init (R, '&㡫', cmDouble, bfNormal)));
		R.Assign (39, 1, 40, 16);
		New (VS, Init (R, lfDefault));
		R.Assign (1, 1, 39, 16);
		New (List, Init (R, VS, Base));
		Insert (List);
		Insert (VS);
		R.Assign (1, 21, 20, 22);
		New (Stat, Init (R, List));
		Insert (Stat);
		List^.GrowMode := gfGrowHiY or gfGrowHiX;
		VS^.GrowMode := gfGrowHiX or gfGrowLoX or gfGrowHiY;
		Stat^.GrowMode := gfGrowHiY or gfGrowLoY;
	end;

procedure TPltWork.HandleEvent (Var Event : TEvent);
	procedure DoNew;
		var
			F	: PForm;
			P	: PPltItem;
			D	: TDate;
		begin
			New (F, Init ('', Base^.Number));
			if ValidView (F) <> NIL then
				begin
					D.__ := SystemDate;
					F^.Date^.SetData (D);
					if DeskTop^.ExecView (F) <> cmCancel then
						begin
							New (P, Init);
							F^.GetDAta (P^);
							Base^.Insert (P);
							Inc (Base^.Number);
							List^.SetRange (Base^.Count);
							Base^.Modif := True;
						end;
					F^.Free;
				end;
		end;

	procedure DoDouble;
		var
			F	: PForm;
			P	: PPltItem;
			D	: TDate;
			R	: Real;
			N	: Longint;
		begin
			New (F, Init ('', Base^.Number));
			P := Base^.At (List^.Focused);
			if ValidView (F) <> NIL then
				begin
					N := P^.Number;
					P^.Number := Base^.Number;
					F^.SetData (P^);
					P^.Number := N;
					D.__ := SystemDate;
					F^.Date^.SetData (D);
					R := 0;
					F^.Summa^.SetData (R);
					Message (F, evBroadCast, cmSummaChange, F^.Summa);
					if DeskTop^.ExecView (F) <> cmCancel then
						begin
							New (P, Init);
							F^.GetData (P^);
							Base^.Insert (P);
							Inc (Base^.Number);
							List^.SetRange (Base^.Count);
							Base^.Modif := True;
						end;
					F^.Free;
				end;
		end;

	procedure DoEdit;
		var
			F	: PForm;
			P	: PPltItem;
		begin
			New (F, Init ('஢', 0));
			P := Base^.At (List^.Focused);
			if (P <> NIL) and (ValidView (F) <> NIL) then
				begin
				F^.SetData (P^);
				if DeskTop^.ExecView (F) <> cmCancel then
					begin
						F^.GetData (P^);
						List^.SetRange (Base^.Count);
						Base^.Modif := True;
					end;
				F^.Free;
				end;
		end;

	procedure DoDel;
		begin
			if (MessageBox (#3' ⢨⥫쭮 '#13+
						#3'㤠   ?',
						NIL, mfConfirmation + mfYesNoCancel) = cmYes)
				and
			(MessageBox (#3' ----- ⮣  !',
							NIL, mfConfirmation + mfYesNoCancel) = cmYes) then
				begin
				Base^.AtFree (List^.Focused);
				List^.SetRange (Base^.Count);
				Base^.Modif := True;
				end;
		end;

	procedure DoPrint;
		var
			P	: PPltItem;
			N,
			I,
			C	: Integer;
			D	: PDialog;
			M	: PPrintMaster;
			R	: TRect;
			F	: Integer;
			B	: Boolean;
			S	: PProgresBar;
			V	: PLabel;
			G,H : String;
			E	: TEvent;
		label
			Skip;
		begin
			P := Base^.At (List^.Focused);
			if PrintPromt (PrintSetup, ' ⥦ 祭') then
			begin
				R.Assign (0, 0, 30, 8);
				New (D, Init (R, 'e...'));
				with D^ do Options := Options or ofCentered;
				R.Assign (4, 2, 26, 3);
				New (M, Init (R, 0));
				R.Assign (5, 1, 14, 2);
				New (V, Init (R, 'ਭ:', M));
				R.Assign (2, 6, 28, 7);
				New (S, Init (R));
				D^.Insert (V);
				D^.Insert (S);
				D^.Insert (M);
				DeskTop^.Insert (D);
			if D^.Fork (6000, 4) then
				begin
{			PrintSetup.Count := 2;}
				for C := 0 to PrintSetup.Count - 1 do
				with M^ do
					begin
						Clear;
						Top (PrintSetup.Top);
						To12;
						LeftMagrin (PrintSetup.Left);
						SetPXMode (PrintSetup.Frames);
						if (PrintSetup.Frames and 1 <> 0) and (PrintSetup.Quality = 0) then SetDraftGraf;
						if PrintSetup.Quality = 2 then ToLQ;
						N := Base^.FormLen;
						for I := 1 to N do
							begin
								PrintStr (Base^.GetForm (I));
								PrintStr (#27'E');
								PrintStr (Base^.GetLine (P^, I));
								PrintStr (#27'F');
								PrintStr (#13#10);
								S^.SetValue (Longint (I + C * N) * 100 div (N * PrintSetup.Count));
							end;
						PrintChar (#12);
					end;
				D^.Free;
			end;
		end;
	end;

	var
		P	: PPltItem;
	label
		Ex;
	begin
		TDialog.HandleEvent (Event);
		if Base = NIL then Exit;
		case Event.What of
			evCommand	:
				case Event.Command of
				cmNew	:	DoNew;
				cmEdit	:	if Base^.Count > 0 then DoEdit;
				cmDel	:	if Base^.Count > 0 then DoDel;
				cmDouble:	if Base^.Count > 0 then DoDouble;
				cmPrint :	if Base^.Count > 0 then DoPrint;
				cmSave	:	if Base^.Modif then Save;
				else
				goto Ex;
				end;
			evKeyDown	:
				case Event.Command of
				kbLeft	:
					with List^ do
						begin
							if ViewAt = ByNumber then
								ViewAt := ByDest
							else
								Dec (ViewAt);
							DrawView
						end;
				kbRight :
					with List^ do
						begin
							if ViewAt = ByDest then
								ViewAt := ByNumber
							else
								Inc (ViewAt);
							DrawView;
						end;
				kbIns,
				kbCtrlEnter :
					if Base^.Count > 0 then
						begin
							P := Base^.At (List^.Focused);
							Base^.SetSortedStyle (List^.ViewAt);
							List^.DrawView;
							List^.FocusItem (Base^.IndexOf (P));
						end;
				else
				Exit;
				end;
		else
			goto Ex;
		end;
		ClearEvent (Event);
		UpDateCommand;
		Stat^.DrawView;
		Ex:
	end;

function TPltWork.Save;
	begin
		Stream.Reset;
		Stream.Seek (0);
		Stream.WriteSignature (Skey);
		if Base <> NIL then
			Base^.Store (Stream);
		Stream.Flush;
		if Stream.Status <> stOk then
			begin
				MessageBox (#3'訡   䠩 ~%s~.', @FileName, mfError + mfCancelButton);
				Save := False;
				Base^.Modif := True;
			end
		else
			begin
				Base^.Modif := False;
				Save := True;
			end;
	end;

function TPltWork.Valid (Command : Word) : Boolean;
	var
		B	: Boolean;
	begin
		case Command of
			cmValid :	if Base = NIL then
						begin
							B := False;
							MessageBox (#3'訡 㧪 䠩 ~%s~.', @FileName, mfError + mfCancelButton);
						end
					else
						B := True;
			cmClose,
			cmQuit	:	if (Base = NIL) or (not Base^.Modif) then
						B := True
					else
						case MessageBox (#3' 﫨 䠩 ~%s~'#13#13#3'࠭  ?', @FileName, mfConfirmation + mfYesNoCancel) of
							cmNo	: B := True;
							cmYes	: B := Save;
						else
							B := False;
						end;
		else
			B := True;
		end;
		Valid := B and TDialog.Valid (Command);
	end;

procedure TPltWork.UpDateCommand;
	begin
		DisableCommands ([cmSave, cmNew, cmEdit, cmDouble, cmPrint, cmDel]);
		if (Base <> NIL) and (State and sfActive <> 0) then
			begin
				if Base^.Count > 0 then
				EnableCommands ([cmDel, cmEdit, cmDouble, cmPrint, cmNew])
				else
				EnableCommands ([cmNew]);
				if Base^.Modif then
				EnableCommands ([cmSave]);
			end;
	end;

procedure TPltWork.SetState (AState : Word; Enable : Boolean);
	begin
		TDialog.SetState (AState, Enable);
		case AState of
			sfActive	:
				if Stat <> nil then
				begin
					Stat^.SetState (sfVisible, Enable);
					UpDateCommand;
				end;
		end;
	end;

destructor TPltWork.Done;
	begin
		TDialog.Done;
		PObject (Base)^.Free;
		DisposeStr (FileName);
		Stream.Done;
	end;

{**************************************************************** TPltList **}
constructor TPltList.Init (Var R : TRect; VS : PScrollBar; APlt : PPltCollection);
	begin
		TListViewer.Init (R, 1, NIL, VS);
		Base := APlt;
		if Base <> NIL then SetRange (Base^.Count);
	end;

procedure TPltList.SelectItem (Item : Integer);
	begin
		if (Base <> NIL) and (Item < Base^.Count) then
			With PPltItem (Base^.At (Item))^ do
				Mark := not Mark;
	end;

function TPltList.IsSelected (Item : Integer) : Boolean;
	begin
		IsSelected := PPltItem (Base^.At (Item))^.Mark;
	end;

function MCopy (P : PString; I : Integer) : String; near;
	begin
		if P = NIL then
			MCopy := Space (I)
		else
			if Length (P^) >= I then
				MCopy := Copy (P^, 1, I)
			else
				MCopy := P^ + Space (I - Length (P^));
	end;

procedure MakeStr (Var S : String; Var Item : TPltItem; At, Sr : TPltSorted); near;
	var
		I	: TPltSorted;
		C	: String [42];
	begin
		for I := ByNumber to ByDest do
			begin
				case At of
				ByNumber	: Str (Item.Number : 7, C);
				ByDate	:
					begin
						FormatDate (Item.Date, C);
						C := MCopy (@C, 15);
					end;
			{	BySumma	: Str (Item.Summa : 14 : 2, C);}
				BySour	: C := MCopy (Item.Sour.Name, 20);
				ByDest	: C := MCopy (Item.Dest.Name, 20);
				end;
				if At = Sr then
				S := S + '~' + C + '~'
				else
				S := S + C;
				Inc (At);
				if At > ByDest then At := ByNumber;
				if I < ByDest then S := S + '';
			end;
		ReplaceChar (S, #10, '');
		ReplaceChar (S, #13, '');
	end;

function TPltList.GetText (Item, MaxLen : Integer) : String;
	var
		S	: String;
	begin
		if (Base = NIL) or (Item >= Base^.Count) then
			GetText := ''
		else
			begin
				if IsSelected (Item) then
				S := ''
				else
				S := ' ';
				MakeStr (S, PPltItem (Base^.At (Item))^, ViewAt, Base^.SortedBy);
				GetText := S;
			end;
	end;

procedure TPltList.Draw;
	var
		I,
		J,
		Item	: Integer;
		NormalColor,
		FocusedColor,
		MarkerColor,
		Color	: Word;
		ColWidth,
		CurCol	: Integer;
		B		: TDrawBuffer;
		SCOff	: Byte;
	begin
		Color := Lo (GetColor (1));
		if State and (sfSelected + sfActive) = (sfSelected + sfActive) then
			FocusedColor := {Color or Lo (}GetColor (3){) shl 8}
		else
			FocusedColor := Color or Lo (GetColor (4)) shl 8;
		NormalColor := Color or GetColor (5) shl 8;
		MarkerColor := Color or GetColor (6) shl 8;
		ColWidth := Size.X div NumCols + 1;
		for I := 0 to Size.Y - 1 do
			begin
				for J := 0 to NumCols - 1 do
				begin
					Item := I + TopItem;
					CurCol := J * ColWidth;
					if (Focused = Item) and (Range > 0) then
						begin
							Color := FocusedColor;
							SCOff := 0;
						end
					else
						if Item = Marker then
							begin
								Color := MarkerColor;
								SCOff := 6;
							end
						else
							begin
								Color := NormalColor;
								SCOff := 4;
							end;
					MoveChar (B [CurCol], ' ', Color, ColWidth);
					if Item < Range then
						begin
							MoveCStr (B [CurCol + 1], Copy (GetText (Item, J), 1, ColWidth + 1), Color);
{							if ShowMarkers then
								begin
									WordRec (B [CurCol]).Lo := Byte (SpecialChars [SCOff]);
									WordRec (B [CurCol + ColWidth - 2]).Lo := Byte (SpecialChars [SCOff+1]);
								end;
}						end;
					MoveChar (B [CurCol + ColWidth - 1], #179, GetColor (5), 1);
				end;
				WriteLine (0, I, Size.X, 1, B);
			end;
	end;

{**************************************************************** TPltStat **}
constructor TPltStat.Init (Var R : TRect; AThe : PPltList);
	begin
		TView.Init (R);
		The := AThe;
	end;

procedure TPltStat.Draw;
	Var
		B	: TDrawBuffer;
		S	: String [80];
		C	: Word;
		F	: Char;
		L	: array [0..1] of Longint;
	begin
		if State and sfDragging = 0 then
			begin
				C := GetColor (2);
				F := #205;
			end
		else
			begin
				C := GetColor (3);
				F := #196;
			end;
		MoveChar (B, F, C, Size.X);
		if (The^.Base <> NIL) and (The^.Base^.Count > 0) then
			begin
				L [0] := The^.Focused + 1;
				L [1] := The^.Base^.Count;
				FormatStr (S, ' %d / %d ', L);
				MoveStr (B [8 - Pos ('/', S)], S, C);
				if The^.Base^.Modif then WordRec (B [1]).Lo := Ord ('*');
			end;
		WriteLine (0, 0, Size.X, Size.Y, B);
	end;

procedure TPltStat.SetState (AState : Word; Enable : Boolean);
	begin
		TView.SetState (AState, Enable);
		if AState = sfDragging then DrawView;
	end;

{******************************************************************* TForm **}
constructor TForm.Init (ATitle : String; ANum : Longint);
	var
		Ind : PIndicator;
		VS,
		HS	: PScrollBar;
		R	: TRect;
		V	: PView;
		S	: String [16];
	begin
		Str (ANum, S);
		R.Assign (0, 0, 74, 20);
		TDialog.Init (R, ATitle + ' N ' + S);
		Options := Options or ofCentered;
		R.Assign (8, 1, 23, 2);
		New (Summa, Init (R)); Insert (Summa);
		R.Assign (1, 1, 8, 2);
		Insert (New (PLabel, Init (R, '㬬', Summa)));
		R.Assign (29, 1, 54, 2);
		New (Date, Init (R)); Insert (Date);
		R.Assign (23, 1, 29, 2);
		Insert (New (PLabel, Init (R, '', Date)));
		Sour.Init (1, 3, Self, False);
		Dest.Init (1, 8, Self, True);
		R.Assign (17, 13, 72, 14);
		V := New (PSummaScript, Init (R)); Insert (V);
		R.Assign (1, 13, 17, 14);
		Insert (New (PLabel, Init (R, '㬬 ய', V)));
		R.Assign (14, 19, 73, 20);
		New (HS, Init (R, lfDefault));
		R.Assign (73, 14, 74, 19);
		New (VS, Init (R, lfDefault));
		R.Assign (2, 19, 13, 20);
		New (Ind, Init (R));
		R.Assign (1, 14, 73, 19);
		New (Memo, Init (R, HS, VS, Ind, 1024)); Insert (Memo); Insert (Memo);
		Insert (Ind); Insert (VS); Insert (HS);
		R.Assign (52, 1, 62, 3);
		Insert (New (PButton, Init (R, cOkStr, cmOk, bfDefault)));
		R.Assign (62, 1, 71, 3);
		Insert (New (PButton, Init (R, cCancelStr, cmCancel, bfNormal)));
	end;

procedure TForm.HandleEvent (Var Event : TEvent);
begin
	TDialog.HandleEvent (Event);
	case Event.What of
		evKeyDown	:
			case Event.KeyCode of
				kbUp	: SelectNext (True);
				kbDown	: SelectNext (False);
				kbPgUp	: Summa^.Select;
				kbPgDn	: Memo^.Select;
			else
				Exit;
			end;
	else
		Exit;
	end;
	ClearEvent (Event);
end;

procedure TForm.GetData (Var R);
	var
		D	: TPltItem absolute R;
		I	: Integer;
	begin
		I := Pos ('', Title^);
		Val (Copy (Title^, I + 2, 255), D.Number, I);
		Summa^.GetData (D.Summa);
		Date^.GetData (D.Date);
		Sour.GetData (D.Sour);
		Dest.GetData (D.Dest);
		with D do
			if Memo <> NIL then
				FreeMem (Memo, Memo^.Length + 2);
		I := Memo^.DataSize;
		GetMem (D.Memo, I);
		Memo^.GetData (D.Memo^);
	end;

procedure TForm.SetData (Var R);
	var
		D	: TPltItem absolute R;
		S	: String;
	begin
		Lock;
		Str (D.Number, S); S := 'N '+ S;
		ReMakeStr (Title, S);
		Summa^.SetData (D.Summa);
		Date^.SetData (D.Date);
		Sour.SetData (D.Sour);
		Dest.SetData (D.Dest);
		Memo^.SetData (D.Memo^);
		Message (@Self, evBroadCast, cmSummaChange, Summa);
		UnLock;
		ReDraw;
	end;

{******************************************************************* TCmen **}
constructor TCmen.Init (X, Y : Integer; Var By : TGroup; As : Boolean);
	const
		Text	: array [Boolean] of array [0..1] of String [11] = (
			('~⥫騪','⥫騪'),
			('~⥫','⥫ ')
		);

	var
		R	: TRect;
		P	: PInputLine;
		L	: PLabel;
		procedure Assign (X1, Y1, Dx, Dy : Integer); near;
			begin
				R.Assign (X1, Y1, X1 + Dx, Y1 + Dy);
				R.Move (X, Y);
			end;
	begin
		TObject.Init;
		Assign (18, 0, 32, 2); New (Name, Init (R, NIL, NIL, NIL, 128)); By.Insert (Name);
		Assign (0, 0, 12, 1); New (L, Init (R, Text [As, 0], Name)); By.Insert (L);

		Assign (6, 1, 12, 1); New (Code, Init (R, 20)); By.Insert (Code);
		Assign (1, 1, 5, 1); New (L, Init (R, '', Code)); By.Insert (L);

		Assign (53, 0, 18, 1); New (Schet, Init (R, 20)); By.Insert (Schet);
		Assign (50, 0, 3, 1); New (L, Init (R, 'N', Schet)); By.Insert (L);

		if As then
			begin
				Assign (53, 1, 18, 1); New (CodeX, Init (R, 20)); By.Insert (CodeX);
				Assign (50, 1, 3, 1); New (L, Init (R, 'N', CodeX)); By.Insert (L);
			end
		else
			CodeX := NIL;

		Assign (54, 3, 17, 1); if not As then R.Move (0, -1); New (MFO, Init (R, 20)); By.Insert (MFO);
		Assign (50, 3, 4, 1); if not As then R.Move (0, -1); New (L, Init (R, '', MFO)); By.Insert (L);

		Assign (6, 2, 44, 1); New (BankN, Init (R, 64)); By.Insert (BankN);
		Assign (0, 2, 6, 1); New (L, Init (R, '', BankN)); By.Insert (L);

		Assign (19, 3, 31, 1); New (BankC, Init (R, 64)); By.Insert (BankC);
		Assign (1, 3, 18, 1); New (L, Init (R, Text [As, 1] + '  .', BankC)); By.Insert (L);
	end;

procedure TCmen.SetData (Var D : TFData);
	var
		S	: String;
		W	: Word;
	begin
		Str (D.Code, S); Code^.SetData (S);
		if CodeX <> NIL then
			begin
				Str (D.CodeX, S); CodeX^.SetData (S);
			end;
		Str (D.MFO, S); MFO^.SetData (S);
		Str (D.Schet, S); Schet^.SetData (S);
		S := GetStr (D.Name)^;
		W := Length (S) shl 8;
		S [0] := #0;
		Name^.SetData (WordRec (W).Hi);
		BankN^.SetData (GetStr (D.BankN)^);
		BankC^.SetData (GetStr (D.BankC)^);
	end;

function TCmen.GetData (Var D : TFData) : Boolean;
	var
		I,
		J	: Integer;
		S	: String;
		B	: Byte;
	begin
		Val (Code^.Data^, D.Code, J);
		if CodeX <> NIL then
			begin
				Val (CodeX^.Data^, D.CodeX, I); Inc (J, I);
			end;
		Val (MFO^.Data^, D.MFO, I); Inc (J, I);
		Val (Schet^.Data^, D.Schet, I); Inc (J, I);
		ReMakeStr (D.BankN, BankN^.Data^);
		ReMakeStr (D.BankC, BankC^.Data^);
		Name^.GetData (B);
		S [0] := Char (B);
		ReMakeStr (D.Name, S);
		GetData := J = 0;
	end;

end.