
unit	PrintMas;

interface

uses	Objects, Views, Drivers, Dialogs, App, SmartDra, Number, MsgBox,
		SysVars, Dark;

type

	TPrintSetup = record
		Quality		: Word;
		Frames		: Word;
		Count		: Byte;
		Left		: Byte;
		Length		: Byte;
		Page		: Byte;
		Top			: Byte;
		Bottom		: Byte;
	end;

	TPrinterStatus = (psNoReady, psReady, psTimeOut, psNoPape, psOff, psError);

	PPrintMaster = ^TPrintMaster;
	TPrintMaster = Object (TView)
		PrNum		: Word;
		constructor Init (Var R : TRect; APrNum : Word);
		function	Status : TPrinterStatus;
		procedure	Promt;
		procedure	PrintChar (C : Char);
		procedure	PrintStr (S : String);
		procedure	ToLQ;
		procedure	ToDraft;
		procedure	To12;
		procedure	To15;
		procedure	To10;
		procedure	To0;
		procedure	ToO;
		procedure	Clear;
		procedure	Top (N : Byte);
		procedure	Bottom (N : Byte);
		procedure	PageLen (N : Byte);
		procedure	LeftMagrin (N : Byte);
		procedure	ToDWid;
		procedure	Centered;
		procedure	RightMagrin (N : Byte);
		procedure	Draw; virtual;
		procedure	HandleEvent (Var Event : TEvent); virtual;
	private
		PredSt		: TPrinterStatus;
		POk			: PButton;
		PCancel		: PButton;
		Time		: Word;
	end;

	function	PrintPromt (Var Info : TPrintSetup; AName : String) : Boolean;
	procedure	SetDraftGraf;

	procedure	SetPXMode (As : Word);

var

	PrintXlat : array [128..255] of Char;

implementation

procedure SetPXMode (As : Word);
	begin
		asm
			PUSH	DS
			POP		ES
			MOV		DI, OFFSET PrintXlat
			CLD
			MOV		CX, 128
			MOV		AL, CL
		@1:	STOSB
			INC		AL
			LOOP	@1
		end;
		if As and 1 = 0 then
			asm
				MOV		DI, OFFSET PrintXlat + 179 - 128
				MOV		CX, 219 - 179
				MOV		AL, ' '
				REP		STOSB
			end;
		if As and 4 <> 0 then
			asm
				MOV		SI, OFFSET PrintXlat + 176 - 128
				MOV		CX, 16
				MOV		AL, $20
			@1:	DEC		SI
				SUB		[SI], AL
				LOOP	@1
				MOV		CL, 16
				MOV		SI, OFFSET PrintXlat + 240 - 128
				MOV		AL, $50
			@2:	DEC		SI
				SUB		[SI], AL
				LOOP	@2
			end;
	end;

procedure SetDraftGraf; assembler;
	asm
		PUSH	DS
		POP		ES
		MOV		DI, OFFSET PrintXlat + 179 - 128
		MOV		CX, 219 - 179
		CLD
		MOV		AL,'+'
		REP		STOSB
		MOV		SI, OFFSET PrintXlat - 128
		MOV		BYTE PTR [SI + 179], '|'
		MOV		BYTE PTR [SI + 186], '|'
		MOV		BYTE PTR [SI + 196], '-'
		MOV		BYTE PTR [SI + 205], '-'
	end;

function PrintPromt (Var Info : TPrintSetup; AName : String) : Boolean;
	var
		D	: PDialog;
		V	: PView;
		R	: TRect;
	begin
		PrintPromt := False;
		R.Assign (0, 0, 45, 16);
		New (D, Init (R, AName));
		with D^ do
			begin
				Options := Options or ofCentered;
				R.Assign (2, 3, 16, 6);
				V := New (PRadioButtons, Init (R,
					NewSItem ('&஥',
					NewSItem ('&祥',
					NewSItem ('&⭮', nil)))));
				Insert (V);
				R.Assign (2, 2, 11, 3);
				V := New (PLabel, Init (R, '&⢮', V));
				Insert (V);

				R.Assign (19, 3, 43, 6);
				V := New (PCheckBoxes, Init (R,
					NewSItem (' &',
					NewSItem ('ન &',
					NewSItem ('訬 &㪢', nil)))));
				Insert (V);
				R.Assign (19, 2, 26, 3);
				V := New (PLabel, Init (R, '&', V));
				Insert (V);

				R.Assign (4, 8, 13, 9);
				V := New (PInputByte, Init (R));
				Insert (V);
				R.Assign (3, 7, 12, 8);
				V := New(PLabel, Init (R, ' &', V));
				Insert (V);

				R.Assign (4, 11, 13, 12);
				V := New (PInputByte, Init (R));
				Insert (V);
				R.Assign (3, 10, 12, 11);
				V := New (PLabel, Init (R, ''#26'&', V));
				Insert (V);

				R.Assign (17, 8, 27, 9);
				V := New (PInputByte, Init (R));
				Insert (V);
				R.Assign (16, 7, 26, 8);
				V := New (PLabel, Init (R, ' &', V));
				Insert (V);

				R.Assign (17, 11, 27, 12);
				V := New (PInputByte, Init (R));
				Insert (V);
				R.Assign (16, 10, 26, 11);
				V := New (PLabel, Init (R, ' &ப', V));
				Insert (V);

				R.Assign (31, 8, 41, 9);
				V := New (PInputByte, Init (R));
				Insert (V);
				R.Assign (30, 7, 40, 8);
				V := New (PLabel, Init (R, ' &', V));
				Insert (V);

				R.Assign (31, 11, 41, 12);
				V := New (PInputByte, Init (R));
				Insert (V);
				R.Assign (30, 10, 40, 11);
				V := New (PLabel, Init (R, ' &', V));
				Insert (V);

				R.Assign (10, 13, 22, 15);
				V := New (PButton, Init (R, '&', cmOk, bfDefault));
				Insert (V);
				R.Move (13, 0);
				V := New (PButton, Init (R, cCancelStr, cmCancel, bfNormal));
				Insert (V);
				FocusNext (True);
			end;
		if ValidView (D) <> NIL then
			begin
				D^.SetData (Info);
				if DeskTop^.ExecView (D) = cmOk then
					begin
						D^.GetData (Info);
						PrintPromt := True;
					end;
				D^.Free;
			end;
	end;

{************************************************************ TPrintMaster **}
var
	CurPrn	: PPrintMaster;

procedure PrnHandle; far;
	var
		P	: PPrintMaster;
	begin
{		P := CurPrn;
		while PtrRec (P).Seg > 0 do
			begin
				P^.Status;
				P := P^.NextPr;
			end;
}	end;

constructor TPrintMaster.Init (Var R : TRect; APrNum : Word);
	begin
		TView.Init (R);
		EventMask := evCommand;
		Options := ofPreProcess;
		PrNum := APrNum;
		Status;
	end;

procedure TPrintMaster.HandleEvent (Var Event : TEvent);
begin
	if (PtrRec (POk).Seg <> 0) and (Event.What = evCommand) then
		begin
			case Event.Command of
				cmOk,
				cmYes		:
					begin
						DisposeObj (POk);
						DisposeObj (PCancel);
					end;
				cmNo,
				cmCancel	:
					Owner^.Destroy;
			else
				Exit
			end;
			ClearEvent (Event);
		end;
end;

function TPrintMaster.Status : TPrinterStatus; assembler;
asm
	LES		DI, Self
	MOV		DX, ES:[DI].PrNum
	MOV		AX, $0200
	INT		17H
	MOV		AL, psOff
	CMP		AH, $30
	JE		@1
	TEST	AH, $40
	JNE		@1
	MOV		AL, psNoPape
	TEST	AH, $20
	JNE		@1
	CMP		AX, $0803
	JE		@1
	MOV		AL, psTimeOut
	TEST	AH, $01
	JNE		@1
	MOV		AL, psNoReady
	TEST	AH, $80
	JE		@1
	MOV		AL, psError
	TEST	AH, $08
	JNE		@1
	MOV		AL, psReady
@1: LES		DI, Self
	CMP		AL, ES:[DI].PredSt
	JE		@2
	MOV		ES:[DI].PredSt, AL
	PUSH	ES
	MOV		DX, SEG TimerLow
	MOV		ES, DX
	MOV		DX, ES:TimerLow
	POP		ES
	CMP		DX, ES:[DI].Time
	JE		@2
	MOV		ES:[DI].Time, DX
	PUSH	AX
	PUSH	ES
	PUSH	DI
	CALL	DrawView
	POP		AX
@2:
end;

procedure TPrintMaster.Draw;
var
	B : TDrawBuffer;
const
	strPrStatus : array [TPrinterStatus] of String [11] = (
		' ~⮢',
		'  ~⮢',
		' ~',
		'~ 㬠',
		' ~몫祭',
		'~訡');
begin
	MoveChar (B, ' ', GetColor (1), Size.X);
	MoveCStr (B [1], strPrStatus [PredSt], GetColor (1));
	WriteLine (0, 0, Size.X, 1, B);
end;

procedure TPrintMaster.PrintStr (S : String);
var
	I	: Integer;
begin
	for I := 1 to Length (S) do
		PrintChar (S [I]);
end;

procedure TPrintMaster.Promt;
var
	S : String;
	R : TRect;
	O : PWindow;
const
	msTitle	: String [17] = '訡  ';
begin
	if PtrRec (POk).Seg = 0 then
		begin
			O := PWindow (Owner);
			R.A.Y := Origin.Y + 2;
			with O^ do
				begin
					R.A.X := (Size.X - 22) shr 1;
					R.B.X := R.A.X + 10;
					R.B.Y := R.A.Y + 2;
					S := Title^;
					ReMakeStr (Title, msTitle);
					New (POk, Init (R, cYesStr, cmYes, bfDefault)); Insert (POk);
					R.Move (12, 0);
					New (PCancel, Init (R, cNoStr, cmCancel, bfNormal)); Insert (PCancel);
					POk^.Select;
					Select;
				end;
			while PtrRec (POk).Seg <> 0 do
				begin
					_;
					Status;
				end;
			with O^ do
				begin
					ReMakeStr (Title, S);
					ReDraw;
				end;
		end;
end;


procedure TPrintMaster.PrintChar (C : Char);
label
	Wait, Go;
begin
	goto Go;
	Wait:
	_;
	Go:
	asm
	@1:	LES		SI, Self
		PUSH	ES
		PUSH	SI
		CALL	Status
		CMP		AL, psNoReady
		JE		Wait
		CMP		AL, psReady
		JNE		@3
		LES		SI, Self
		MOV		DX, ES:[SI].PrNum
		MOV		AH, 0
		MOV		AL, C
		TEST	AL, AL
		JNS		@2
		MOV		BX, OFFSET PrintXlat - 128
		XLAT
	@2:	INT		17H
		TEST	AH, 9
		JE		@4
	@3:	PUSH	ES
		PUSH	SI
		CALL	Promt
		JMP		@1
	@4:
	end;
end;

procedure TPrintMaster.ToLQ;
begin
	PrintStr (#27'x1');
end;

procedure TPrintMaster.ToDraft;
begin
	PrintStr (#27'x0');
end;

procedure TPrintMaster.To12;
begin
	PrintStr (#27'M');
end;

procedure TPrintMaster.To10;
begin
	PrintStr (#27'P');
end;

procedure TPrintMaster.To15;
begin
	PrintChar (#15);
end;

procedure TPrintMaster.To0;
begin
	PrintStr (#27'~'#1);
end;

procedure TPrintMaster.ToO;
begin
	PrintStr (#27'~0');
end;

procedure TPrintMaster.LeftMagrin (N : Byte);
begin
	PrintStr (#27'l' + Char (N));
end;

procedure TPrintMaster.Top (N : Byte);
begin
	PrintStr (#27'c' + Char (N));
end;

procedure TPrintMaster.Bottom (N : Byte);
begin
	PrintStr (#27'N' + Char (N));
end;

procedure TPrintMaster.PageLen (N : Byte);
begin
	PrintStr (#27'C' + Char (N));
end;

procedure TPrintMaster.ToDWid;
begin
	PrintStr (#27'W'#1);
end;

procedure TPrintMaster.Clear; assembler;
asm
	LES		SI, Self
	PUSH	ES
	PUSH	SI
	MOV		AX, 0100H
	MOV		DX, ES:[SI].PrNum
	INT		17H
	CALL	Status
end;

procedure TPrintMaster.Centered;
begin
	PrintStr (#27'a'#1);
end;

procedure TPrintMaster.RightMagrin (N : Byte);
begin
	PrintStr (#27'Q' + Char (N));
end;

end.