{$D+}

unit	Otdel;

interface

uses	Objects, Person, TheAll;

type

	POtdel = ^TOtdel;
	TOtdel = Object (TStringCollection)
		NextTab		: Longint;
		Head		: TDosStream;
		FileName	: PString;
		Modif		: Boolean;
		All			: TAll;

		constructor Create (Var AName : String);
		constructor	Init (AName : PString);
		constructor	Load (Var S : TStream);
		procedure	Store (Var S : TStream);
		procedure	PutItem (Var S : TStream; Item : Pointer); virtual;
		function	GetItem (Var S : TStream) : Pointer; virtual;
		procedure	FreeItem (Item : Pointer); virtual;
		function	KeyOf (Item : Pointer) : Pointer; virtual;
		procedure	Insert (Item : Pointer); virtual;
		function	XSearch (Var AName : String) : Integer;
		procedure	Save;
		procedure	Error (ACode, AInfo : Integer); virtual;
		destructor	Done; virtual;
	end;

implementation

uses	Memory, ByDos;

const
	Skey	: Longint = $A0C798FB;
	Sign	: String [27] = 'ZPL 1.O  㤭 ';

constructor TOtdel.Create (Var AName : String);
	const
		Q : array [0..10] of char = '';
	begin
		TCollection.Init (10, 50);
		FileName := NewStr (AName + '  ');
		dosErase (FileName^);
		Head.Init (FileName^, stCreate);
		Head.WriteSignature (SKey);
		while Head.GetPos < 127 do Head.Write (Q [Random (SizeOf (Q))], 1);
		Variab.Init;
		Limits.Init;
		All.Init;
		Save;
	end;

constructor TOtdel.Init (AName : PString);
	var
		I : Integer;
	begin
		TObject.Init;
		FileName := AName;
		Head.Init (FileName^, stOpen);
		if Head.ReadSignature (SKey) then
			begin
				Head.Seek (128);
				Head.Read (NextTab, SizeOf (NextTab));
				Head.Read (I, SizeOf (I));
				Limits.Load (Head);
				Variab.Load (Head);
				All.Load (Head);
				Delta := 50;
				SetLimit (I);
				if Limit >= I then
					begin
						while (I > 0) and not LowMemory and (Head.Status = stOk) do
							begin
								AtInsert (Count, GetItem (Head));
								Dec (I);
							end;
						if LowMemory then Head.Status := 1;
					end
				else
					Head.Status := 1;
			end;
	end;

constructor	TOtdel.Load (Var S : TStream);
	begin
		Init (S.ReadStr);
		S.Status := Head.Status;
	end;

procedure TOtdel.Store (Var S : TStream);
	begin
		S.WriteStr (FileName);
	end;

procedure TOtdel.Insert (Item : Pointer);
	begin
		Inc (NextTab);
		PPerson (Item)^.Info.Number := NextTab;
		AtInsert (Count, Item);
	end;

function TOtdel.XSearch (Var AName : String) : Integer;
	var
		I : Integer;
	begin
		for I := Count - 1 downto 0 do
			if PPerson (At (I))^.Info.FIO = AName then
				begin
					XSearch := I;
					Exit;
				end;
		XSearch := -1;
	end;

procedure TOtdel.PutItem (Var S : TStream; Item : Pointer);
	begin
		PPerson (Item)^.Store (S);
	end;

function TOtdel.GetItem (Var S : TStream) : Pointer;
	begin
		if not LowMemory then
			GetItem := New (PPerson, Load (S))
		else
			begin
				S.Status := 1;
				GetItem := nil;
			end;
	end;

procedure TOtdel.Save;
	var
		I : Integer;
	begin
		Head.Seek (128);
		Head.Write (NextTab, SizeOf (NextTab));
		Head.Write (Count, SizeOf (Count));
		Limits.Store (Head);
		Variab.Store (Head);
		All.Store (Head);
		for I := 0 to Count - 1 do
			PutItem (Head, At (I));
		Head.Flush;
	end;

function TOtdel.KeyOf (Item : Pointer) : Pointer;
	begin
		KeyOf := @PPerson (Item)^.Info.FIO;
	end;

procedure TOtdel.FreeItem (Item : Pointer); assembler;
	asm
		LES		SI, Item
		PUSH	ES
		PUSH	SI
		CALL	TObject.Free
	end;

procedure TOtdel.Error (ACode, AInfo : Integer);
	begin
	end;

destructor TOtdel.Done;
	begin
		DisposeStr (FileName);
		Head.Done;
		TCollection.Done;
	end;

end.
