{$D+}

unit	Person;

interface

uses	Objects, DataServ;

type

	PPerson = ^TPerson;

	TLimits = Object (TObject)
		PDnal		: array [0..10] of record Level, Stavka : Real end;
		MaxPole		: Real;
		MaxHiGor	: Real;
		MaxRaion	: Real;
		constructor Load (Var S : TStream);
		procedure	Store (Var S : TStream);
	end;

	TVariab = Object (TObject)
		HiGor		: array [0..10] of Real;
		constructor	Load (Var S : TStream);
		procedure	Store (Var S : TStream);
	end;

	TRealDay = Object
		Beg		: Real;
		From	: Real;
		By		: Byte;
		function Result : Real;
	end;

	TOklad	= (aOklad, aSdel, aTime);
	TPrem	= (aOk, aNo, aPerev, aUnol);

	TTarif = Object
		As		: TOklad;
		The		: TRealDay;
		function Result	(By : Integer) : Real;
	end;

	TDobav = Object
		Class		: Real;
		NotNorm		: Real;
		Radio		: Real;
		WorkHi		: Real;
		Brigad		: Real;
		Pole		: Boolean;
		Pension		: Boolean;
		Personal	: Real;
		function	Result1 (By : Real) : Real;
		function	Result2 (By : Real) : Real;
	end;

	TDateInfo = Object
		Rod,
		Priem,
		Uvol,
		NeprStag,
		OutOtpusk,
		InOtpusk,
		Perexod,
		Modif		: TDate;
	end;

	TIspList = Object
		Data	: array [0..3] of Real;
	end;

	TForOtpusk = Object
		Data	: array [0..12] of
					record
						Lgot	: Byte;
						Summa	: Real;
					end;
	end;

	TForNalog = Object
		Data	: array [0..2] of Real;
	end;

	TZar13 = Object
		Data	: array [0..2] of
					record
						ByPred	: Real;
						ByCur	: Real;
						Shifr	: Longint;
					end;
		Count	: Byte;
		SKoof	: Real;
	end;

	TForSred = Object
		Data	: array [0..2] of
					record
						Days	: Byte;
						CDays	: Byte;
						ZarB	: Real;
						ZarS	: Real;
					end;
	end;

	TForPens = Object
		SumP	: Real;
		Npor	: Longint;
		SumE	: Real;
		SumO	: Real;
		SumV	: Real;
	end;

	TTabel = Object
		Number	: Longint;
		ByCale	: Byte;
		TimeDay	: Byte;
		TimeHour: Integer;
		CdelDay	: Byte;
		PoleD	: Byte;
		NeO		: Byte;
		NeE		: Byte;
		NeP		: Byte;
		NeB		: Byte;
		NeK		: Byte;
		NeU		: Byte;
		NeN		: Byte;
		NeR		: Byte;
		NeD		: Byte;
		NeUD	: Byte;
		PrHour	: Byte;
		BxHour	: Byte;
		Norma	: Byte;
		HiGor	: array [0..3] of Byte;
		RV		: Byte;
	end;

	TInfo = Object
		FIO			: String [50];
		Number		: Longint;
		Kateg		: Byte;
		Tarif		: TTarif;
		PremInfo	: TPrem;
		IspList		: TIspList;
		Dobav		: TDobav;
		DateInfo	: TDateInfo;
		TabPerev	: Longint;
{		UniProf		: TUniProf;}
	end;

	TLic = Object
		Ost			: Real;
		ForOtpusk	: TForOtpusk;
		Zad			: Real;
		Znm			: Real;
		ForNalog	: TForNalog;
		Zar13		: TZar13;
		ForSred		: TForSred;
		ForPens		: TForPens;
		PredTab		: array [0..12] of TTabel;
	end;

	TResult = Object
		Number	: Longint;
		Kateg	: Byte;
		Oklad	: Real;
		Chisl	: Real;
		Work	: Byte;
		BS		: Byte;
		LG		: Byte;
		Ost		: Real;

		Sdel	: Real;
		Time	: Real;
		Dop		: Real;
		Class	: Real;
		Other1	: Real;
		HiGor	: Real;
		Raion	: Real;
		Other2	: Real;
		SSday	: Byte;
		SSsum	: Real;
		OTday	: Byte;
		OTsum	: Real;
		Pole	: Real;
		AllNach	: Real;

		First	: Real;
		Second	: Real;
		PDnal	: Real;
		IspList	: Real;
		Depon	: Real;
		Other	: Real;
		AllCut	: Real;

		NewOst	: Real;
	end;

	PPesron = ^TPerson;
	TPerson = Object (TObject)
		IOpos		: Longint;
		Info		: TInfo;
		Tabel		: TTabel;
		LicC		: TLic;
		Rez			: TResult;
		Modif		: Boolean;
		procedure	Recalc;
		constructor	Load (Var S : TStream);
		procedure	Store (Var S : TStream);
	end;

const	PersonSize = SizeOf (TInfo) + SizeOf (TTabel) + SizeOf (TLic);

Var

	Limits	: TLimits;
	Variab	: TVariab;

const

	Day	: Byte = 10;


implementation
{***************************************************************** TPerson **}

procedure TPerson.Recalc;
	var
		ByOklad : Real;
	begin
		Rez.Number := Info.Number;
{		ByOklad := Info.Tarif.Result (Tabel.Count);}
		Rez.Kateg	:= Info.Kateg;
		Rez.Oklad	:= Info.Tarif.The.Result;
		if Tabel.TimeDay <> 0 then
			Rez.Chisl	:= Tabel.ByCale / Tabel.TimeDay
		else
			Rez.Chisl := 0;
{		Rez.Work	:= Tabel.Work;
		Rez.BS		:= Tabel.BS;
		Rez.LG		:= Tabel.LG;
		Rez.Ost		:= LicC.Ost;}

	   {Rez.Sdel	:=}if Info.Tarif.As = aSdel then Rez.Sdel := ByOklad else Rez.Sdel := 0;
	   {Rez.Time	:=}if Info.Tarif.As <> aSdel then Rez.Time := ByOklad else Rez.Time := 0;
		Rez.Dop		:= 0;
		Rez.Class	:= ByOklad * (Info.Dobav.Class + Info.Dobav.NotNorm);
		Rez.Other1	:= Info.Dobav.Result1 (ByOklad);
{		Rez.HiGor	:= ByOklad * Tabel.HiGor.Result;}
		Rez.Raion	:= ByOklad * 0.13;
		Rez.Other2	:= Info.Dobav.Result2 (ByOklad);
		Rez.SSday	:= 0;
		Rez.SSsum	:= 0;
		Rez.OTday	:= 0;
		Rez.OTsum	:= 0;
		Rez.Pole	:= 0;
		Rez.AllNach	:= Rez.SDel + Rez.Time + Rez.Dop + Rez.Class + Rez.Other1 + Rez.HiGor +
						Rez.Raion + Rez.Other2 + Rez.SSsum + Rez.OTsum + Rez.Pole;

		Rez.First	:= 0;
		Rez.Second	:= 0;
		Rez.PDnal	:= 0;
		Rez.IspList	:= 0;
		Rez.Depon	:= 0;
		Rez.Other	:= 0;
		Rez.AllCut	:= Rez.First + Rez.Second + Rez.PDnal + Rez.IspList + Rez.Depon + Rez.Other;

		Rez.NewOst	:= Rez.Ost + Rez.AllNach - Rez.AllCut;
	end;

constructor TPerson.Load (Var S : TStream);
	begin
		IOpos := S.GetPos;
		S.Read (Info, PersonSize);
		Recalc;
		Modif := False;
	end;

procedure TPerson.Store (Var S : TStream);
	var
		L : Longint;
	begin
		L := S.GetPos;
		if Modif or (L <> IOpos) then
			begin
				IOpos := L;
				S.Write (Info, PersonSize);
				Modif := Modif and (S.Status = stOk);
			end
		else
			S.Seek (L + PersonSize);
	end;

{****************************************************************** TRealDay **}
function TRealDay.Result : Real;
	begin
		if Day > By then
			Result := Beg * By + From * (Day - By)
		else
			Result := Beg * Day;
	end;

{****************************************************************** TTarif **}
function TTarif.Result (By : Integer) : Real;
	begin
		case As of
			aOklad:	Result := The.Result;
			aSdel:	Result := The.Result * By;
			aTime:	Result := The.Result * By;
		end
	end;

{****************************************************************** TDobav **}
function TDobav.Result1 (By : Real) : Real;
	begin
		Result1 := By * (Radio + WorkHi + Brigad);
	end;

function TDobav.Result2 (By : Real) : Real;
	var
		K : Real;
	begin
		if Pole then K := 0.33 else K := 0;
		if Pension then K := K + 0.25;
		Result2 := By * K + Personal;
	end;

{***************************************************************** TLimits **}
constructor TLimits.Load (Var S : TStream);
	begin
		S.Read (PDnal, SizeOf (TLimits) - SizeOf (TObject));
	end;

procedure TLimits.Store (Var S : TStream);
	begin
		S.Write (PDnal, SizeOf (TLimits) - SizeOf (TObject));
	end;

{***************************************************************** TVariab **}
constructor TVariab.Load (Var S : TStream);
	begin
		S.Read (HiGor, SizeOf (TVariab) - SizeOf (TObject));
	end;

procedure TVariab.Store (Var S : TStream);
	begin
		S.Write (HiGor, SizeOf (TVariab) - SizeOf (TObject));
	end;
end.

