{$D+,F+}

unit	PrintMas;

interface

uses	Objects, Views, Drivers, Dialogs, App, SmartDra, Number, MsgBox;

type

	TPrintSetup = record
		Quality		: Word;
		Frames		: Word;
		Count		: Byte;
		Left		: Byte;
		Length		: Byte;
		Page		: Byte;
		Top			: Byte;
		Bottom		: Byte;
	end;

	TPrinterStatus = (psNoReady, psReady, psTimeOut, psNoPape, psOff);

	PPrintMaster = ^TPrintMaster;
	TPrintMaster = Object (TView)
		PrNum	: Word;
		constructor Init (Var R : TRect; APrNum : Word);
{		function	SetMode (Qal, Fra : Word; Left : Word) : Boolean;}
		function	PrintLine (Var Line : TTabText) : Boolean;
		function	Status : TPrinterStatus;
		function	Promt : Boolean;
		function	PrintChar (C : Char) : Boolean;
		function	PrintStr (S : String) : Boolean;
		function	ToLQ : Boolean;
		function	ToDraft : Boolean;
		function	To12 : Boolean;
		function	To15 : Boolean;
		function	To10 : Boolean;
		function	To0 : Boolean;
		function	ToO : Boolean;
		function	Clear : Boolean;
		function	Top (N : Byte) : Boolean;
		function	Bottom (N : Byte) : Boolean;
		function	PageLen (N : Byte) : Boolean;
		function	LeftMagrin (N : Byte) : Boolean;
		function	ToDWid : Boolean;
		function	Centered: Boolean;
		function	RightMagrin (N : Byte) : Boolean;
		procedure	Draw; virtual;
	end;

	function	PrintPromt (Var Info : TPrintSetup; AName : String) : Boolean;
	procedure	SetDraftGraf;

	procedure	SetPXMode (As : Word);

var

	PrintXlat : array [128..255] of Char;

implementation

procedure SetPXMode (As : Word);
	begin
		asm
			PUSH	DS
			POP		ES
			MOV		DI, OFFSET PrintXlat
			CLD
			MOV		CX, 128
			MOV		AL, CL
		@1:	STOSB
			INC		AL
			LOOP	@1
		end;
		if As and 1 = 0 then
			asm
				MOV		DI, OFFSET PrintXlat + 179 - 128
				MOV		CX, 219 - 179
				MOV		AL, ' '
				REP		STOSB
			end;
		if As and 4 <> 0 then
			asm
				MOV		SI, OFFSET PrintXlat + 176 - 128
				MOV		CX, 16
				MOV		AL, $20
			@1:	DEC		SI
				SUB		[SI], AL
				LOOP	@1
				MOV		CL, 16
				MOV		SI, OFFSET PrintXlat + 240 - 128
				MOV		AL, $50
			@2:	DEC		SI
				SUB		[SI], AL
				LOOP	@2
			end;
	end;

procedure SetDraftGraf; assembler;
	asm
		PUSH	DS
		POP		ES
		MOV		DI, OFFSET PrintXlat + 179 - 128
		MOV		CX, 219 - 179
		CLD
		MOV		AL,'+'
		REP		STOSB
		MOV		SI, OFFSET PrintXlat - 128
		MOV		BYTE PTR [SI + 179], '|'
		MOV		BYTE PTR [SI + 186], '|'
		MOV		BYTE PTR [SI + 196], '-'
		MOV		BYTE PTR [SI + 205], '-'
	end;

function PrintPromt (Var Info : TPrintSetup; AName : String) : Boolean;
	var
		D	: PDialog;
		V	: PView;
		R	: TRect;
	begin
		PrintPromt := False;
		R.Assign (0, 0, 45, 16);
		New (D, Init (R, AName));
		with D^ do
			begin
				Options := Options or ofCentered;
				R.Assign (2, 3, 16, 6);
				V := New (PRadioButtons, Init (R,
					NewSItem ('஥',
					NewSItem ('祥',
					NewSItem ('⭮', nil)))));
				Insert (V);
				R.Assign (2, 2, 11, 3);
				V := New (PLabel, Init (R, '&⢮', V));
				Insert (V);

				R.Assign (19, 3, 43, 6);
				V := New (PCheckBoxes, Init (R,
					NewSItem (' ࠬ',
					NewSItem ('ન ',
					NewSItem ('訬 㪢', nil)))));
				Insert (V);
				R.Assign (19, 2, 26, 3);
				V := New (PLabel, Init (R, '', V));
				Insert (V);

				R.Assign (4, 8, 13, 9);
				V := New (PInputByte, Init (R));
				Insert (V);
				R.Assign (3, 7, 12, 8);
				V := New(PLabel, Init (R, ' &', V));
				Insert (V);

				R.Assign (4, 11, 13, 12);
				V := New (PInputByte, Init (R));
				Insert (V);
				R.Assign (3, 10, 12, 11);
				V := New (PLabel, Init (R, ''#26'&', V));
				Insert (V);

				R.Assign (17, 8, 27, 9);
				V := New (PInputByte, Init (R));
				Insert (V);
				R.Assign (16, 7, 26, 8);
				V := New (PLabel, Init (R, ' &', V));
				Insert (V);

				R.Assign (17, 11, 27, 12);
				V := New (PInputByte, Init (R));
				Insert (V);
				R.Assign (16, 10, 26, 11);
				V := New (PLabel, Init (R, ' &ப', V));
				Insert (V);

				R.Assign (31, 8, 41, 9);
				V := New (PInputByte, Init (R));
				Insert (V);
				R.Assign (30, 7, 40, 8);
				V := New (PLabel, Init (R, ' &', V));
				Insert (V);

				R.Assign (31, 11, 41, 12);
				V := New (PInputByte, Init (R));
				Insert (V);
				R.Assign (30, 10, 40, 11);
				V := New (PLabel, Init (R, ' &', V));
				Insert (V);

				R.Assign (10, 13, 22, 15);
				V := New (PButton, Init (R, '&', cmOk, bfDefault));
				Insert (V);
				R.Move (13, 0);
				V := New (PButton, Init (R, cCancelStr, cmCancel, bfNormal));
				Insert (V);
				SelectNext (True);
			end;
		PrintPromt := ExecuteDialog (D, @Info) = cmOk;
	end;

{************************************************************ TPrintMaster **}
constructor TPrintMaster.Init (Var R : TRect; APrNum : Word);
	begin
		TView.Init (R);
		PrNum := APrNum;
	end;

function TPrintMaster.Status : TPrinterStatus; assembler;
	asm
		LES		DI, Self
		MOV		DX, ES:[DI].PrNum
		MOV		AH, 2
		INT		17H
		MOV		AL, psOff
		TEST	AH, $40
		JNE		@1
		MOV		AL, psNoPape
		TEST	AH, $20
		JNE		@1
		MOV		AL, psTimeOut
		TEST	AH, $01
		JNE		@1
		MOV		AL, psNoReady
		TEST	AH, $80
		JE		@1
		MOV		AL, psReady
	@1:	MOV		AH, 0
	end;

procedure TPrintMaster.Draw;
	var
		B : TDrawBuffer;
	const
		strPrStatus : array [TPrinterStatus] of String [10] = (
	{psNoReady, psReady, psTimeOut, psNoPape, psOff}
			' ⮢',
			'  ⮢',
			' ',
			' 㬠',
			' 몫祭');
	begin
		MoveChar (B, ' ', GetColor (1), Size.X);
		MoveCStr (B [1], strPrStatus [Status], GetColor (1));
		WriteLine (0, 0, Size.X, 1, B);
	end;

function TPrintMaster.PrintStr (S : String) : Boolean;
	var
		I : Integer;
	begin
		PrintStr := False;
		for I := 1 to Length (S) do
			if not PrintChar (S [I]) then
				Exit;
		PrintStr := True;
	end;

function TPrintMaster.PrintLine (Var Line : TTabText) : Boolean;
	var
		I	: Integer;
		W	: Integer;
		P	: Pointer;
		PredSt : Byte;
	label
		St, Other;
	begin
		W := Line.Length;
		I := 0;
		P := Line.Ptr;
		PrintLine := True;
		PredSt := $FF;
		Other:
		asm
			LES		SI, Self
			MOV		DX, ES:[SI].PrNum
			LES		SI, P
			ADD		SI, I
			MOV		CX, W
			SUB		CX, I
			MOV		DI, CX
			JCXZ	@3
			MOV		BX, OFFSET PrintXlat - 128
		@1: CLD
			SEGES	LODSB
			CMP		AL, 128
			JB		@2
			XLAT
		@2:	MOV		AH, 0
			INT		17H
			TEST	AH, 9
			JNE		@6
			MOV		AH, 2
			INT		17H
			CMP		AH, PredSt
			JNE		@5
		@3:	LOOP	@1
		@4:	JMP		Ok
		@5: MOV		PredSt, AH
			PUSH	DI
			PUSH	ES
			PUSH	SI
			PUSH	CX
			PUSH	DX
			PUSH	BX
			LES		DI, Self
			PUSH	ES
			PUSH	DI
			CALL	DrawView
			POP		BX
			POP		DX
			POP		CX
			POP		SI
			POP		ES
			POP		DI
			JMP		@3
		@6: SUB		DI, CX
			ADD		I, DI
		end;
			DrawView;
			if Promt then goto Other else
				begin
					PrintLine := False;
					Exit;
				end;
		St:
		asm
			LES		SI, Self
			MOV		DX, ES:[SI].PrNum
			MOV		AX, $000D
			INT		17H
			MOV		AX, $000A
			INT		17H
		end;
	end;

function TPrintMaster.Promt : Boolean;
	var
		S : String;
		P : PString;
	begin
		P := @S;
		case Status of
			psOff:		S := 'ਭ 몫祭';
			psTimeOut:	S := '  ';
			psNoPape:	S := ' 㬠  ਭ';
		else
			S := 'ਭ ⮢';
		end;
		Promt := MessageBox (#3'~%s~,'#13+
							#13+
							#3'த ?',
							@P, mfError + mfYesNoCancel) = cmYes;
	end;

function TPrintMaster.PrintChar (C : Char) : Boolean; assembler;
	asm
	@1:	LES		SI, Self
		MOV		DX, ES:[SI].PrNum
		MOV		AH, 0
		MOV		AL, C
		INT		17H
		MOV		AH, 2
		INT		17H
		SAR		AH, 1
		SAR		AH, 1
		SAR		AH, 1
		AND		AH, 1
		XOR		AH, 1
		MOV		AL, AH
		JNE		@2
		PUSH	ES
		PUSH	SI
		CALL	Promt
		TEST	AL, AL
		JNE		@1
	@2:
	end;

function TPrintMaster.ToLQ : Boolean;
	begin
		ToLQ := PrintStr (#27'x1');
	end;

function TPrintMaster.ToDraft : Boolean;
	begin
		ToDraft := PrintStr (#27'x0');
	end;

function TPrintMaster.To12 : Boolean;
	begin
		To12 := PrintStr (#27'M');
	end;

function TPrintMaster.To10 : Boolean;
	begin
		To10 := PrintStr (#27'P');
	end;

function TPrintMaster.To15 : Boolean;
	begin
		To15 := PrintChar (#15);
	end;

function TPrintMaster.To0 : Boolean;
	begin
		To0 := PrintStr (#27'~'#1);
	end;

function TPrintMaster.ToO : Boolean;
	begin
		ToO := PrintStr (#27'~0');
	end;

function TPrintMaster.LeftMagrin (N : Byte) : Boolean;
	begin
		LeftMagrin := PrintStr (#27'l' + Char (N));
	end;

function TPrintMaster.Top (N : Byte) : Boolean;
	begin
		Top := PrintStr (#27'c' + Char (N));
	end;

function TPrintMaster.Bottom (N : Byte) : Boolean;
	begin
		Bottom := PrintStr (#27'N' + Char (N));
	end;

function TPrintMaster.PageLen (N : Byte) : Boolean;
	begin
		PageLen := PrintStr (#27'C' + Char (N));
	end;

function TPrintMaster.ToDWid;
	begin
		ToDWid := PrintStr (#27'W'#1);
	end;

function TPrintMaster.Clear : Boolean;
	begin
		Clear := PrintStr (#27'@');
	end;

function TPrintMaster.Centered : Boolean;
	begin
		Centered := PrintStr (#27'a'#1);
	end;

function TPrintMaster.RightMagrin (N : Byte) : Boolean;
	begin
		RightMagrin := PrintStr (#27'Q' + Char (N));
	end;
end.