{Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}

unit AntiSet;

interface

uses	Anti, MsgBox, App, Crt;

{$I VERSION}

type
	SOper = (opError, opRead, opScan, opWrite, opDone, opNotFound);
	TStat = procedure (Pos : Longint; Opr : SOper);

function SearchLabel (Var F : File; Var Position : LongInt): Boolean;
procedure ChangeCRCinEXE (Var F : File; OldTab, NewTab : Pointer; Size : Word);
function ClearProtect (Var F : File; Pos : Longint): Boolean;
function SetProtect (Var F : File; Pos : Longint): Boolean;
function SeeError (Var F : File; Msg : String): Boolean;
procedure InitAntiSet;

Var
	Sum	: Longint;
	See	: TStat;

implementation

const
	ReadErr		: String [13] = '訡 ⥭';
	WriteErr	: String [13] = '訡 ';
	CrcErr  	: String [25] = '  ४஢ EXECRC';

type
	PWord = ^Word;
	ByteArray = Array [0..10000] of byte;

const

	BufSize = 4 * 1024;

Var
	FileBuffer : Array [0..BufSize - 1] of char;

function ClearProtect (Var F : File; Pos : Longint): Boolean;
Var
	Buffer,
	Tmp		: array [0..10] of longint;
	Count	: Integer;
	I, J	: Integer;
begin
	ClearProtect := False;
	Seek (F, Pos);
	BlockRead (F, Buffer, SizeOf (Buffer), Count);
	if SeeError (F, ReadErr) or (Count <> SizeOf (Buffer)) then Exit;
	Move (Buffer, Tmp, SizeOf (Buffer));
	Count := Buffer [0];
	if Count = 0 then Exit;
	for I := 1 to Count do
		begin
			if Buffer [I] = Sum then
				begin
					for J := I to 9 do
						Buffer [J] := Buffer [J+1];
					Buffer[10] := 0;
					Dec (Buffer[0]);
					Dec (I);
				end;
		end;
	Seek (F, Pos);
	BlockWrite (F, Buffer, SizeOf (Buffer), Count);
	if SeeError (F, WriteErr) or (Count <> SizeOf (Buffer)) then Exit;
	ChangeCRCinEXE (F, @Tmp, @Buffer, SizeOf (Buffer) shr 1);
	ClearProtect := True;
end;

function SetProtect (Var F : File; Pos : Longint): Boolean;
Var
	Buffer,
	Tmp		: array [0..10] of longint;
	Count	: Word;
	I		: Word;
begin
	SetProtect := False;
	Seek (F, Pos);
	BlockRead (F, Buffer, SizeOf (Buffer), Count);
	if SeeError (F, ReadErr) or (Count <> SizeOf (Buffer)) then Exit;
	Move (Buffer, Tmp, SizeOf (Buffer));
	Count := Buffer [0];
	if Count >= 10 then Exit;
	for I := 1 to Count do
		if Buffer [I] = Sum then Exit;
	Inc (Count);
	Buffer[Count] := Sum;
	Buffer[0] := Count;
	ChangeCRCinEXE (F, @Tmp, @Buffer, SizeOf (Buffer) shr 1);
	Seek (F, Pos);
	BlockWrite (F, Buffer, SizeOf (Buffer), Count);
	if SeeError (F, WriteErr) or (Count <> SizeOf (Buffer)) then Exit;
	SetProtect := True;
end;

function SearchLabel (Var F : File; Var Position : LongInt) : Boolean;
	function Scan (Mem : Pointer; Size : Word): Word; near; assembler;
	asm
		PUSH	DS
		LES		DI, Mem
		MOV		CX, Size
		LDS		SI, Anti.__info_anti_set_
		CLD
		LODSW
		LODSW
		SUB		AX, SI
		MOV		DX, AX
		MOV		BX, SI
	@1: MOV		SI, BX
		MOV		DH, DL
	@2:	CMPSB
		JE		@3
		LOOP	@1
	@5:	XOR		AX, AX
		DEC		AX
		JMP		@9
	@3:	DEC		DH
		JE		@4
		LOOP	@2
		JMP		@5
	@4: SUB		CX, Size
		MOV		AX, CX
		NEG		AX
		INC		AX
	@9:	POP		DS
	end;

Var
	Pos		: Longint;
	Size	: Longint;
	Count	: Word;
	Lot		: Longint;
	I, J	: Integer;
begin
	SearchLabel := False;
	Position := -1;
	Seek (F, 0);
	Pos := 0;
	Size := FileSize (F);
	while Pos < Size do
		begin
			Lot := Size - Pos;
			if Lot > BufSize then Lot := BufSize;
			See (Pos, opRead);
			BlockRead (F, FileBuffer, Lot, Count);
			if Lot <> Count then
				begin
					See (Pos, opError);
					Delay (500);
					Exit;
				end;
			J := 0;
			See (Pos, opScan);
			I := Scan (@FileBuffer, Lot);
			if I <> -1 then
				begin
					SearchLabel := True;
					Position := Pos + I;
					See (Pos, opDone);
					Exit;
				end;
			Inc (Pos, Lot);
		end;
	See (Pos, opNotFound);
end;

procedure ChangeCRCinEXE (Var F : File; OldTab, NewTab : Pointer; Size : Word);
Var
	Buffer	: array [0..$12 div 2] of Word;
	Count	: Word;
	CRC		: Word;
begin
	Seek (F, 0);
	BlockRead (F, Buffer, SizeOf (Buffer), Count);
	if SeeError (F, ReadErr + CrcErr)or
	 (Count <> SizeOf (Buffer))then Exit;
	if Buffer [0] = $5A4D {MZ} then
		begin
			CRC := Buffer [$12 div 2 ];
			for Count := 1 to Size do
				begin
					Inc (CRC, PWord (OldTab)^);
					Inc (PWord (OldTab));
				end;
			for Count := 1 to Size do
				begin
					Dec (CRC, PWord (NewTab)^);
					Inc (PWord (NewTab));
				end;
			Buffer [$12 div 2] := CRC;
			Seek (F, 0);
			BlockWrite (F, Buffer, SizeOf (Buffer), Count);
			if SeeError (F, WriteErr + CrcErr) or (Count <> SizeOf (Buffer)) then Exit;
		end;
end;

procedure InitAntiSet; assembler;
asm
@0: PUSH	DS
	MOV	AX, 0FB00H
	MOV	DS, AX
	XOR	SI, SI
	XOR	BX, BX
	XOR	DX, DX
	MOV	CX, 8192
	CLD
@1: LODSW
	ADD		BX, AX
	XOR		DX, AX
	ROR		BX, 1
	XCHG	BH, AL
	LOOP	@1
@4: POP		DS
	MOV		WORD PTR Sum, BX
	MOV		WORD PTR Sum + 2, DX
end;

function SeeError (Var F : File; Msg : String): Boolean;
	Var
		P : ^ByteArray;
		S : String;
		I : Integer;
	begin
		SeeError := False;
		P := @F;
		I := IOResult;
		if I <> 0 then
			begin
				DeskTop^.UnLock;
				I := 48;
				while P^[I] <> 0 do
					begin
						S [I-47] := Char (P^[I]);
						Inc (I);
					end;
				S[0] := char (I-48);
				P := @S;
				MessageBox (#3' ~%s~'#13+
							#13+
							#3+Msg, @P, mfError+mfCancelButton);
				SeeError := True;
				Exit;
			end;
	end;
end.