{1/2 Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}

unit Cale;

interface

uses	Drivers, Objects, App, Views, Dos, Dialogs, DataServ;

{$I VERSION}

type

	PCalendarView = ^TCalendarView;
	TCalendarView = Object (TView)
		Date		: TDate;
		CurDate		: TDate;
		constructor	Init (Bounds : TRect);
		constructor	Load (Var S : TStream);
		procedure	HandleEvent (Var Event : TEvent); virtual;
		procedure	Draw; virtual;
		procedure	Store (Var S : TStream);
	end;

	PCalendarWindow = ^TCalendarWindow;
	TCalendarWindow = Object (TWindow)
		constructor Init;
	end;

const

	RCalendarView : TStreamRec = (
		ObjType	: 10020;
		VmtLink	: Ofs (TypeOf (TCalendarView)^);
		Load	: @TCalendarView.Load;
		Store	: @TCalendarView.Store);

	RCalendarWindow : TStreamRec = (
		ObjType	: 10021;
		VmtLink	: Ofs (TypeOf (TCalendarWindow)^);
		Load	: @TCalendarWindow.Load;
		Store	: @TCalendarWindow.Store);

procedure RegisterCalendar;

implementation

{********************************************************* TCalendarWindow **}
constructor TCalendarWindow.Init;
Var
	R	: TRect;
begin
	R.Assign (1, 1, 23, 11);
	TWindow.Init (R, '', 0);
	Flags := Flags and not (wfZoom + wfGrow);
	GrowMode :=0;
	Palette := wpCyanWindow;
	GetExtent (R);
	R.Grow (-1, -1);
	Insert (New (PCalendarView, Init (R)));
end;

{*********************************************************** TCalendarView **}
constructor TCalendarView.Init (Bounds : TRect);
begin
	TView.Init (Bounds);
	Options := Options or ofSelectable;
	EventMask := EventMask or evMouseAuto;
	Date.__ := SystemDate;
	CurDate := Date;
end;

constructor TCalendarView.Load (Var S : TStream);
begin
	TView.Load (S);
	CurDate.__ := SystemDate;
	S.Read (Date, SizeOf (Date));
end;

procedure TCalendarView.Draw;
const
	Width	= 20;
Var
	i,
	j,
	DayOf,
	Days			: Integer;
	CurDays			: ShortInt absolute Date;
	S				: String;
	B				: array [0..Width] of Word;
	Color,
	BoldColor,
	SpecialColor	: Byte;

	function Num2Str (I : Integer) : String;
	Var
		S	: String;
	begin
		Str (I + 1: 2, S);
		Num2Str := S;
	end;

begin
	Color := Lo (GetColor (6));
	BoldColor := Lo (GetColor (7));
	Date.Day := 0;
	DayOf := DayOfWeek (Date);
	Days := DaysInMonth (Date.Mon, Date.Year);
	Str (Date.Year : 4, S);
	MoveChar (B, ' ', Color, Width);
	MoveStr (B, MonthNames [Date.Mon], Color);
	MoveStr ( B [11], S + ' '#30' '#31, Color);
	WriteLine (0, 0, Width, 1, B);
	MoveChar (B, ' ', Color, Width);
	MoveStr (B, '      ', Color);
	WriteLine (0, 1, Width, 1, B);
	CurDays := - DayOf;
	for I := 1 to 6 do
		begin
			MoveChar (B, ' ', Color, Width);
			for J := 0 to 6 do
				begin
					if (CurDays < 0) or (CurDays >= Days) then
						MoveStr (B [J * 3], ' ', Color)
					else
						if Date.__ = CurDate.__ then
							MoveStr (B [J * 3], Num2Str (CurDays), BoldColor)
						else
							MoveStr (B [J * 3], Num2Str (CurDays), Color);
					Inc (CurDays);
				end;
			WriteLine (0, I + 1, Width, 1, B);
		end;
end;

procedure TCalendarView.HandleEvent (Var Event : TEvent);
Var
	Point		: TPoint;
	SelectDay	: Word;
begin
	TView.HandleEvent (Event);
	if (State and sfSelected <> 0) then
		begin
			if Event.What and (evMouseDown + evMouseAuto) <> 0 then
				begin
					MakeLocal (Event.Where, Point);
					if ((Point.X = 16) and (Point.Y = 0)) then
						begin
							Inc (Date.Mon);
							if Date.Mon > 11 then
								begin
									Inc (Date.Year);
									Date.Mon := 0;
								end;
							DrawView;
						end;
					if ((Point.X =	18) and (Point.Y = 0)) then
						begin
							Dec (Date.Mon);
							if Date.Mon < 0 then
								begin
									Dec (Date.Year);
									Date.Mon := 11;
								end;
							DrawView;
						end;
				end
			else
				if Event.What = evKeyDown then
					begin
						if (Lo (Event.KeyCode) = byte ('+')) or (Event.KeyCode = kbDown) then
							begin
								Inc (Date.Mon);
								if Date.Mon > 11 then
									begin
										Inc (Date.Year);
										Date.Mon := 0;
									end;
							end;
						if (Lo (Event.KeyCode) = Byte ('-')) or (Event.KeyCode = kbUp) then
							begin
								Dec (Date.Mon);
								if Date.Mon < 0 then
									begin
										Dec (Date.Year);
										Date.Mon := 11;
									end;
							end;
						DrawView;
					end;
		end;
end;

procedure TCalendarView.Store (Var S : TStream);
begin
	TView.Store (S);
	S.Write (Date, SizeOf (Date));
end;

procedure RegisterCalendar;
begin
	RegisterType (RCalendarView);
	RegisterType (RCalendarWindow);
end;

end.
