{1/2 Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}
{$d+,l+}

unit FileServ;

interface

uses	Dos;

{$I VERSION}

type

	PSearchRec = ^TSearchRec;
	TSearchRec = record
		Attr : Byte;
		Time : Longint;
		Size : Longint;
		Name : string [12];
	end;

function ValidFileName (var FileName : PathStr) : Boolean;
function DriveValid (Drive : Char) : Boolean;
function PathValid (var Path : PathStr) : Boolean;
function IsWild (var S : String) : Boolean;
function GetCurDir : DirStr;
function IsDir (var S : String) : Boolean;
function Equal (var S1 : String; var S2 : String; Count : Word) : Boolean;
function TmpFile (var Path : PathStr) : Boolean;
function FileExist (FileName : PathStr) : Boolean;
function GetCurDrive : Char;
procedure FullPath (var Path : PathStr);
procedure ClrIO;
function IsMem (Size : Longint) : Boolean;

const
	IllegalPathChars : String [14] = ' ;, =+<>|" [] /'#39;

implementation

uses	Sysvars, CharLog;

function DriveValid (Drive : Char) : Boolean; assembler;
asm
	CALL  DosVersion
	CMP		AL, 3
	JL		@0
	MOV		AX, 4408H
	MOV		BL, Drive
	SUB		BL, 'A'-1
	INT		21H
	JNC		@1
@0:	MOV		AH, 36H
	MOV		DL, Drive
	SUB		DL, 'A'-1
	INT		21H
	INC		AX
	JE		@2
@1:	MOV		AL, 1
@2:
end;

function PathValid (var Path : PathStr) : Boolean;
var
	ExpPath	: PathStr;
	F		: File;
	SR		: SearchRec;
begin
	ExpPath := FExpand (Path);
	if Length (ExpPath) <= 3 then
		PathValid := DriveValid (ExpPath [1])
	else
		begin
			if ExpPath [Length (ExpPath)] = '\' then Dec (ExpPath [0]);
			FindFirst (ExpPath, Directory, SR);
			PathValid := (DosError = 0) and (SR.Attr and Directory <> 0);
		end;
end;

function ValidFileName (var FileName : PathStr) : Boolean;
var
	Dir		: DirStr;
	Name	: NameStr;
	Ext		: ExtStr;

begin
	ValidFileName := True;
	FSplit (FileName, Dir, Name, Ext);
	if not ((Dir = '') or PathValid (Dir)) or Contains (Name, IllegalPathChars) or Contains (Dir, IllegalPathChars) then
		ValidFileName := False;
end;

function GetCurDir : DirStr;
var
	CurDir	: DirStr;
begin
	GetDir (0, CurDir);
	if Length (CurDir) > 3 then
		begin
			Inc (CurDir [0]);
			CurDir [Length (CurDir)] := '\';
		end;
	GetCurDir := CurDir;
end;

function IsWild (var S : String) : Boolean;
begin
	IsWild := (Pos ('?', S) > 0) or (Pos ('*', S) > 0);
end;

function IsDir (var S : String) : Boolean;
var
	SR	: SearchRec;
begin
	FindFirst (S, Directory, SR);
	if DosError = 0 then
		IsDir := SR.Attr and Directory <> 0
	else
		IsDir := False;
end;

function Equal (var S1 : String; var S2 : String; Count : Word) : Boolean;
var
	I	: Word;
begin
	Equal := False;
	if (Length (S1) < Count) or (Length (S2) < Count) then Exit;
	for I := 1 to Count do
		if UpCase (S1 [I]) <> UpCase (S2 [I]) then Exit;
	Equal := True;
end;

function IsMem (Size : Longint) : Boolean;
begin
	IsMem := MaxAvail > Size + 1024;
end;

function TmpFile (var Path : PathStr) : Boolean;
var
	I		: Word;
	Dir		: PathStr;
	Name	: String [8];
	Ext		: String [4];
Label
	St1;
begin
	I := 0;
	FSplit (Path, Dir, Name, Ext);
	if Ext [0] < #2 then Ext := '.TMP';
	St1 :
	Str (TimerLow + I, Name);
	Insert ('D', Name, 1);
	Path := Dir + Name + '.*';
	Inc (I);
	if FileExist (Path) then goto St1;
	if I = 100 then
		begin
			TmpFile := False;
			Exit;
		end;
	Path := Dir + Name + Ext;
	TmpFile := True;
end;

function FileExist (FileName : PathStr) : Boolean;
var
	R	: SearchRec;
begin
	FindFirst (FileName, AnyFile, R);
	FileExist := DosError = 0;
end;

procedure FullPath (var Path : PathStr);
var
	Name	: String [16];
	Ext		: String [8];
begin
	FSPlit (Path, Path, Name, Ext);
	if Pos (':', path) < 1 then
		path := GetCurDrive + ':' + path;
	if Byte (path [0]) < 3 then
		GetDir (Ord (path [1]) - Ord ('A') + 1, path);
	path := path + Name + Ext;
	if path [Length (path)] <> '\' then	path := path + '\';
end;

procedure ClrIO;
begin
	System.InOutRes := 0;
end;

function GetCurDrive : Char; assembler;
asm
	MOV	AH, 19H
	INT	21H
	ADD	AL, 'A'
end;

end.