{1/2 Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}

unit Gadgets;

interface

uses	Objects, Views;

{$I VERSION}

type

	PHeapView = ^THeapView;
	THeapView = object(TView)
		OldMax		: LongInt;
		constructor	Init (Var Bounds : TRect);
		procedure	Draw; virtual;
		procedure	Update;
	end;

	PClockView = ^TClockView;
	TClockView = Object (TView)
		LastTimer	: Longint;
		TimeStr		: String [5];
		constructor	Init (Var Bounds : TRect);
		procedure	Draw; virtual;
		procedure	Update;
	end;

implementation

uses	Dos, SysVars, App, Drivers, CharLog;

constructor THeapView.Init (Var Bounds : TRect);
begin
	TView.Init (Bounds);
	OldMax := 0;
end;

procedure THeapView.Draw;
Var
	S	: String;
	B	: TDrawBuffer;
	C	: Byte;
begin
{	OldMax := MaxAvail;}
	OldMax := MemAvail;
	C := Lo (GetColor (2));
	MoveChar (B, ' ', C, Size.X);
	Str (OldMax, S);
	MoveStr (B, S, C);
	WriteLine (0, 0, Size.X, 1, B);
end;

procedure THeapView.Update;
begin
	if OldMax <> MemAvail then DrawView;
end;

constructor TClockView.Init (Var Bounds : TRect);
begin
	TView.Init (Bounds);
	LastTimer := Timer;
	TimeStr := '';
end;

procedure TClockView.Draw;
Var
	B	: TDrawBuffer;
	C	: Byte;
begin
	C := Lo (GetColor (2));
	MoveChar (B, ' ', C, Size.X);
	MoveStr (B, TimeStr, C);
	WriteLine (0, 0, Size.X, 1, B);
end;

procedure TClockView.Update;
Var
	H,
	M,
	S	: Word;
	V	: String [3];
begin
	if Timer - LastTimer >=  9 then
		begin
			LastTimer := Timer;
			GetTime (H, M, S, S);
			Str (H : 2, TimeStr);
			Str (M : 3, V);
			ReplaceChar (V, ' ', '0');
			if Abs ((TimerLow mod 18)) > 9 then
				V [1] := ':'
			else
				V [1] := ' ';
			TimeStr := TimeStr + V;
			DrawView;
		end;
	end;

end.
