{1/2 Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}

unit HistList;

{*****************************************************************************
History buffer structure :

	Byte Byte String          Byte Byte String
	...
	 0  Id  History string  0  Id  History string        
	...

*****************************************************************************}

interface

{$I VERSION}

const

	HistoryBlock	: Pointer = NIL;
	HistorySize		: Word = 1024;
	HistoryUsed		: Word = 0;

procedure HistoryAdd (Id : Byte; Var Str : String);
function HistoryCount (Id : Byte) : Word;
function HistoryStr (Id : Byte; Index : Integer) : String;
procedure ClearHistory;

procedure InitHistory;
procedure DoneHistory;

implementation

uses	Objects;

Var
	CurId		: Byte;
	CurString	: PString;

procedure AdvanceStringPointer; near; assembler;
asm
	PUSH	DS
	MOV		CX, HistoryUsed
	MOV		BL, CurId
	LDS		SI, CurString
	MOV		DX, DS
	MOV		AX, DS
	OR		AX, SI
	JZ		@3
	CLD
	JMP		@2
@1:	LODSW
	CMP		AH, BL
	JE		@3
@2:	LODSB
	XOR		AH, AH
	ADD		SI, AX
	CMP		SI, CX
	JL		@1
	XOR		SI, SI
	MOV		DX, SI
@3:	POP		DS
	MOV		CurString.Word [0], SI
	MOV		CurString.Word [2], DX
end;

procedure DeleteString; near; assembler;
asm
	PUSH	DS
	MOV		CX, HistoryUsed
	CLD
	LES		DI, CurString
	MOV		SI, DI
	DEC		DI
	DEC		DI
	PUSH	ES
	POP		DS
	MOV		AL, BYTE PTR [SI]
	XOR		AH, AH
	INC		AX
	ADD		SI, AX
	SUB		CX, SI
	REP		MOVSB
	POP		DS
	MOV		HistoryUsed, DI
end;

procedure InsertString (Id : Byte; Str : String); near; assembler;
asm
	PUSH	DS
	STD
	LES		DX, HistoryBlock
	MOV		DI, HistoryUsed
	LDS		SI, Str
	MOV		BL, [SI]
	INC		BL
	INC		BL
	INC		BL
	XOR		BH, BH
	POP		DS
	PUSH	DS
@1:	MOV		AX, DI
	ADD		AX, BX
	SUB		AX, DX
	CMP		AX, HistorySize
	JL		@2
	DEC		DI
	XOR		AL, AL
	MOV		CX, 0FFFFH
	REPNE	SCASB
	INC		DI
	JMP		@1
@2:	MOV		SI, DI
	ADD		DI, BX
	MOV		HistoryUsed, DI
	PUSH	ES
	POP		DS
	MOV		CX, SI
	SUB		CX, DX
	REP		MOVSB
	CLD
	MOV		DI, DX
	INC		DI
	MOV		AH, Id
	XOR		AL, AL
	STOSW
	LDS		SI, Str
	LODSB
	STOSB
	MOV		CL, AL
	XOR		CH, CH
	REP		MOVSB
	POP		DS
end;

procedure StartId (Id : Byte); near;
begin
	CurId := Id;
	CurString := HistoryBlock;
end;

function HistoryCount (Id : Byte) : Word;
Var
	Count	: Word;
begin
	StartId (Id);
	Count := 0;
	AdvanceStringPointer;
	while PtrRec (CurString).Seg <> 0 do
		begin
			Inc (Count);
			AdvanceStringPointer;
		end;
	HistoryCount := Count;
end;

procedure HistoryAdd (Id : Byte; Var Str : String);
begin
	if Str = '' then Exit;
	StartId (Id);
	AdvanceStringPointer;
	while PtrRec (CurString).Seg <> 0 do
		begin
			if Str = CurString^ then DeleteString;
			AdvanceStringPointer;
		end;
	InsertString (Id, Str);
end;

function HistoryStr (Id : Byte; Index : Integer) : String;
Var
	I	: Integer;
begin
	StartId (Id);
	for I := 0 to Index do AdvanceStringPointer;
		if PtrRec (CurString).Seg <> 0 then
			HistoryStr := CurString^
		else
			HistoryStr := '';
end;

procedure ClearHistory;
begin
	PChar (HistoryBlock)^ := #0;
	HistoryUsed := PtrRec (HistoryBlock).Ofs + 1;
end;

procedure InitHistory;
begin
	GetMem (HistoryBlock, HistorySize);
	ClearHistory;
end;

procedure DoneHistory;
begin
	FreeMem (HistoryBlock, HistorySize);
end;

end.
