{1/2 Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}
{$O-,D+,L+}

unit	Resident;

interface

uses	Objects, Drivers;

{$I VERSION}

type

	PMouseAnimator = ^TMouseAnimator;
	TMouseAnimator = Object (TObject)
		function	Next : Pointer; virtual;
	end;

const

	MouseAnimator	: PMouseAnimator = NIL;
	EventQSize		= 16;
	MouseVisible	: Byte = $FF;
	MouseDrawer		: Pointer = NIL;
	MouseEvents		: Boolean = False;
	MouseReverse	: Boolean = False;
	DoubleDelay		: Word = 8;
	RepeatDelay		: Word = 8;
	LastButtons		: Byte = 0;
	DownButtons		: Byte = 0;
	MouseMark		: Word = 0;

var

{$IFDEF SupportMasterMouse}
	TextMouseAnimators	: array [msNormal..msPress] of PMouseAnimator;
{$ENDIF}
	GraphMouseAnimators	: array [msNormal..msPress] of PMouseAnimator;

	LastDouble		: Boolean;
	LastWhere		: TPoint;
	DownWhere		: TPoint;
	DownTimer		: Word;
	AutoTimer		: Word;
	AutoDelay		: Word;
	MouseIntFlag	: Byte;
	MouseButtons	: Byte;
	MouseWhere		: TPoint;
	MouseLocate		: TRect;
	EventCount		: Word;
	EventQHead		: Word;
	EventQTail		: Word;
	EventQueue		: array [0..EventQSize - 1] of TEvent;
	EventQLast		: record end;

type

	TSysErrorFunc = function (ErrorCode : Integer; Drive : Byte) : Integer;

function SystemError (ErrorCode : Integer; Drive : Byte) : Integer;
{$IFDEF SupportMasterMouse}
procedure DrawGraphMouse;
procedure AdjustMouse (AGraph : Boolean);
{$ELSE}
procedure AdjustMouse;
{$ENDIF}
procedure ReDrawMouse;
procedure DrawTextMouse;
procedure MouseInt;
procedure InitSysError;
procedure DoneSysError;
procedure ShowMouse;
procedure HideMouse;
procedure Open_A000_Font;
procedure Close_A000_Font;

const
	MouseState		: TMouseState = msNoInit;
	SysErrorFunc	: TSysErrorFunc = SystemError;
	SysColorAttr	: Word = $4E4F;
	SysMonoAttr		: Word = $7079;
	CtrlBreakHit	: Boolean = False;
	SaveCtrlBreak	: Boolean = False;
	SysErrActive	: Boolean = False;
	FailSysErrors	: Boolean = False;

implementation

uses	Sysvars, App;

const
	MousePtr		: Word = $FFFF;
	FontOpen		: Boolean = False;

var
	TextMouseImage	: Word;
	GraphMouseImage	: Pointer;
	MouseX			: Integer;
	MouseY			: Integer;
{$IFDEF SupportMasterMouse}
	Image			: array [0..9 * 32 - 1] of Byte;
	Rotate			: array [0..9 * 32 - 1] of Byte;
	FntOff			: Word;
	ShiftX			: Word;
	ShiftY			: Word;
	NewPos			: Word;
	Save			: array [0..8] of Word;
	NewArea			: array [0..8] of Word;
{$ELSE}
	Save			: array [0..1] of Word;
{$ENDIF}

procedure ReDrawMouse; assembler;
asm
	CMP		WORD PTR  MouseDrawer [2], 0
	JE		@1
	CALL	[MouseDrawer]
@1:
end;

{$IFDEF SupportMasterMouse}

procedure DrawGraphMouse; assembler;
asm
	CLI
	PUSH	ES
	PUSH	DI
	PUSH	SI
	PUSH	DX
	PUSH	CX
	PUSH	BX
	PUSH	AX
	PUSH	BP
	CLD
	LES		SI, DWORD PTR GraphMouseImage
	XOR		AX, AX
{	SEGES	LODSW
}	MOV		BX, AX
	CBW
	ADD		AX, MouseY
	XOR		DX, DX
	MOV		CX, DevicesInfo.Vscan
	DIV		CX
	MOV		MouseLocate.A.Y, AX
	ADD		AX, 2
	MOV		MouseLocate.B.Y, AX
	MOV		ShiftY, DX
	MOV		AL, BH
	CBW
	ADD		AX, MouseX
	MOV		CL, 3
	MOV		BX, AX
	SAR		AX, CL
	MOV		MouseLocate.A.X, AX
	ADD		AX, 2
	MOV		MouseLocate.B.X, AX
	CMP		MouseVisible, 0
	JL		@9G
	AND		BX, 07H
	MOV		DI, OFFSET Rotate
	MOV		DL, 16
	PUSH	ES
	PUSH	DS
	POP		ES
	POP		DS
@1T:MOV		CX, BX
	LODSW
	MOV		DH, -1
	JCXZ	@3T
	STC
@2T:RCR		AX, 1
	RCR		DH, 1
	LOOP	@2T
@3T:XCHG	AH, AL
	STOSW
	MOV		AL, DH
	STOSB
	DEC		DL
	JNE		@1T
	MOV		DL, 16
@4T:MOV		CX, BX
	LODSW
	XOR		DH, DH
	JCXZ	@6T
@5T:RCR		AX, 1
	RCR		DH, 1
	LOOP	@5T
@6T:XCHG	AH, AL
	STOSW
	MOV		AL, DH
	STOSB
	DEC		DL
	JNE		@4T
	PUSH	ES
	POP		DS
	MOV		AX, MouseLocate.A.Y
	XOR		BX, BX
	MOV		BL, DevicesInfo.ScreenWidth
	MUL		BX
	ADD		AX, MouseLocate.A.X
	ADD		AX, AX
	MOV		NewPos, AX
	SUB		BX, 3
	ADD		BX, BX
	MOV		DI, OFFSET NewArea
	LDS		SI, DevicesInfo.ScreenBuffer
	ADD		SI, AX
	MOV		DH, 3
@1L:MOV		CX, 3
	REP		MOVSW
	ADD		SI, BX
	DEC		DH
	JNE		@1L
	PUSH	ES
	POP		DS
	MOV		DI, OFFSET Save
	MOV		SI, OFFSET NewArea
	MOV		CL, 9
@2L:MOV		AL, [SI]
	MOV		BX, 8
@3L:CMP		AL, BYTE PTR MouseImage [BX]
	JE		@4L
	DEC		BX
	JNS		@3L
	JMP		@5L
@4L:ADD		BX, BX
	MOV		AX, [DI + BX]
	MOV		[SI], AX
@5L:ADD		SI, 2
	LOOP	@2L
	CALL	Open_A000_Font
	XOR		AX, AX
	MOV		AH, DevicesInfo.CurrentFont
	MOV		CX, 04H
	MOV		BX, 1100000000000000B
	SAL		AX, CL
	AND		BX, AX
	ADD		AX, AX
	ADD		AX, AX
	MOV		SI, AX
	MOV		FntOff, SI
	MOV		DS, SegA000
	MOV		DI, OFFSET Image
	MOV		DX, 1009H
	MOV		BP, OFFSET NewArea + 2
	PUSH	BX
@1G:SUB		BP, 2
	POP		BX
	XCHG	SI, BX
	PUSH	BX
@2G:MOV		AX, ES:[BP]
	ADD		BP, 2
	AND		AH, 00001000B
	JE		@3G
	MOV		CL, 5
	SAL		AX, CL
	ADD		AX, SI
	XCHG	AX, SI
	MOV		CL, DH
	REP		MOVSW
	MOV		SI, AX
	DEC		DL
	JNE		@2G
	POP		BX
	JMP		@5G
@3G:SUB		BP, 2
	POP		BX
	XCHG	SI, BX
	PUSH	BX
@4G:MOV		AX, ES:[BP]
	ADD		BP, 2
	AND		AH, 00001000B
	JNE		@1G
	MOV		CL, 5
	SAL		AX, CL
	ADD		AX, SI
	XCHG	AX, SI
	MOV		CL, DH
	REP		MOVSW
	MOV		SI, AX
	DEC		DL
	JNE		@4G
	POP		BX
@5G:PUSH	ES
	POP		DS
	CALL	Close_A000_Font
	MOV		SI, OFFSET Rotate
	MOV		BX, 3 * 16 - 1
	MOV		BP, ShiftY
	MOV		DI, OFFSET Image
	MOV		AH, 16
	MOV		DX, DevicesInfo.Vscan
@6G:MOV		CX, DX
	ADD		DI, BP
	SUB		CX, BP
	JA		@7G
	ADD		CX, DX
@7G:SUB		BP, DX
	JA		@8G
	XOR		BP, BP
@8G:LODSB
	AND		AL, [DI]
	XOR		AL, [SI+BX]
	MOV		[DI], AL
	ADD		DI, 32
	LODSB
	AND		AL, [DI]
	XOR		AL, [SI+BX]
	MOV		[DI], AL
	ADD		DI, 32
	LODSB
	AND		AL, [DI]
	XOR		AL, [SI+BX]
	MOV		[DI], AL
	SUB		DI, 32 * 2 - 1
	DEC		AH
	JE		@9G
	LOOP	@8G
	ADD		DI, 32 * 3
	SUB		DI, DX
	JMP		@6G
@9G:XOR		DX, DX
	MOV		DL, DevicesInfo.ScreenWidth
	SUB		DX, 3
	ADD		DX, DX
	LES		DI, DevicesInfo.ScreenBuffer
	MOV		SI, MousePtr
	TEST	SI, SI
	JS		@4H
	ADD		DI, SI
	MOV		SI, OFFSET Save
	MOV		CH, 03H
	XOR		BX, BX
@1H:MOV		CL, 03H
@2H:MOV		AL, BYTE PTR MouseImage [BX]
	INC		BX
	CMP		AL, ES:[DI]
	LODSW
	JNE		@3H
	MOV		ES:[DI], AX
@3H:ADD		DI, 2
	DEC		CL
	JNE		@2H
	ADD		DI, DX
	DEC		CH
	JNE		@1H
@4H:PUSH	DS
	POP		ES
	MOV		DI, OFFSET Save
	MOV		SI, OFFSET NewArea
	MOV		CL, 9
	REP		MOVSW
	DEC		CX
	CMP		MouseVisible, 0
	JL		@EQ
	PUSH	NewPos
	CALL	Open_A000_Font
	MOV		DI, FntOff
	MOV		ES, SegA000
	MOV		SI, OFFSET Image
	MOV		CX, 9
	MOV		BX, OFFSET MouseImage
@5H:PUSH	CX
	XOR		AX, AX
	MOV		AL, [BX]
	INC		BX
	MOV		CL, 5
	SHL		AX, CL
	XCHG	AX, DI
	ADD		DI, AX
	MOV		CL, 16
	REP		MOVSW
	XCHG	AX, DI
	POP		CX
	LOOP	@5H
	CALL	Close_A000_Font
	XOR		BX, BX
	MOV		BL, DevicesInfo.ScreenWidth
	MOV		SI, BX
	SUB		SI, 3
	ADD		SI, SI
	LES		DI, DevicesInfo.ScreenBuffer
	ADD		DI, NewPos
	MOV		FntOff, SI
	MOV		SI, OFFSET MouseImage
	MOV		DL, DevicesInfo.ScreenHeight
	SUB		DL, BYTE PTR MouseLocate.A.Y
	JBE		@EX
	CMP		DL, 3
	JB		@6H
	MOV		DL, 3
@6H:MOV		AH, 0F7H
	MOV		DH, BYTE PTR MouseLocate.A.X
	TEST	DevicesInfo.CurrentFont, -1
	JE		@1S
@1W:MOV		CX, 3
	MOV		BH, DH
@2W:LODSB
	CMP		BH, BL
	JAE		@4W
	STOSB
	AND		ES:[DI], AH
	INC		DI
	INC		BH
	LOOP	@2W
@5W:ADD		DI, FntOff
	DEC		DL
	JNE		@1W
	JMP		@EX
@4W:ADD		DI, 2
	INC		BH
	LOOP	@2W
	JMP		@5W
@1S:MOV		CX, 3
	MOV		BH, DH
@2S:LODSB
	CMP		BH, BL
	JAE		@4S
	STOSB
	INC		DI
	INC		BH
	LOOP	@2S
@5S:ADD		DI, FntOff
	DEC		DL
	JNE		@1S
	JMP		@EX
@4S:ADD		DI, 2
	INC		BH
	LOOP	@2S
	JMP		@5S
@EX:POP		CX
@EQ:MOV		MousePtr, CX
	POP		BP
	POP		AX
	POP		BX
	POP		CX
	POP		DX
	POP		SI
	POP		DI
	POP		ES
	STI
end;
{$ENDIF}

procedure DrawTextMouse; assembler;
asm
	CLI
	PUSH	ES
	PUSH	DI
	PUSH	SI
	PUSH	DX
	PUSH	CX
	PUSH	BX
	PUSH	AX
	LES		BX, DevicesInfo.ScreenBuffer
	MOV		SI, -1
	MOV		DI, MousePtr
	MOV		CX, MouseWhere.X
	MOV		MouseLocate.A.X, CX
	MOV		MouseLocate.B.X, CX
	MOV		AX, MouseWhere.Y
	MOV		MouseLocate.A.Y, AX
	MOV		MouseLocate.B.Y, AX
	CMP		MouseVisible, 0
	JL		@2
	MOV		DL, DevicesInfo.ScreenWidth
	MUL		DL
	ADD		AX, CX
	ADD		AX, AX
	XCHG	AX, SI
@2:	OR		DI, DI
	JS		@3
	MOV		AX, WORD PTR Save
	CMP		SI, DI
	JE		@4
	MOV		CX, WORD PTR Save [2]
	CMP		ES:[DI+BX], CX
	JNE		@3
	MOV		ES:[DI+BX], AX
@3: OR		SI, SI
	JS		@5
	MOV		AX, ES:[SI+BX]
	MOV		WORD PTR Save, AX
@4:	AND		AX, WORD PTR TextMouseImage
	XOR		AX, WORD PTR TextMouseImage [2]
	MOV		ES:[SI+BX], AX
	MOV		WORD PTR Save [2], AX
@5:	MOV		MousePtr, SI
	POP		AX
	POP		BX
	POP		CX
	POP		DX
	POP		SI
	POP		DI
	POP		ES
	STI
end;

procedure MouseInt; assembler;
asm
	MOV		SI, SEG @DATA
	MOV		DS, SI
	MOV		SI, CX
	MOV		CL, 3
	SHR		SI, CL
	SHR		DX, CL
	MOV		MouseButtons, BL
	MOV		MouseX, SI
	MOV		MouseY, DX
{$IFDEF SupportMasterMouse}
	TEST	Config.MouseGraph, -1
	JE		@0
	PUSH	AX
	XCHG	AX, DX
	SHR		SI, CL
	XOR		DX, DX
	MOV		CX, DevicesInfo.Vscan
	DIV		CX
	XCHG	AX, DX
	POP		AX
{$ENDIF}
@0:	MOV		MouseWhere.X, SI
	MOV		MouseWhere.Y, DX
	TEST	AX, 11110B
	JE		@2
	CMP		EventCount, EventQSize
	JE		@2
	MOV		ES, Seg0040
	MOV		AX, ES:TimerLow
	MOV		DI, EventQTail
	PUSH	DS
	POP		ES
	CLD
	STOSW
	XCHG	AX, BX
	STOSW
	XCHG	AX, SI
	STOSW
	XCHG	AX, DX
	STOSW
	CMP		DI, OFFSET EventQLast
	JNE		@1
	MOV		DI, OFFSET EventQueue
@1:	MOV		EventQTail, DI
	INC		EventCount
@2:	MOV		MouseIntFlag, 1
@3: MOV		CX, WORD PTR MouseDrawer [2]
	JCXZ	@4
	CALL	[MouseDrawer]
@4:end;

{$IFDEF SupportMasterMouse}
procedure AdjustMouse (AGraph : Boolean); assembler;
{$ELSE}
procedure AdjustMouse; assembler;
{$ENDIF}
asm
	TEST	DevicesInfo.ButtonCount, -1
	JE		@3
	CALL	HideMouse
	PUSH	MouseWhere.X
	PUSH	MouseWhere.Y
{$IFDEF SupportMasterMouse}
{$IFDEF SupportMasterFont}
	TEST	Config.MasterFont, -1
	JE		@1
{$ENDIF}
	TEST	AGraph, -1
	JE		@1
	MOV		WORD PTR MouseDrawer, OFFSET DrawGraphMouse
	MOV		AX, 15
	MOV		CX, 1
	MOV		DX, CX
	INT		33H
	MOV		AX, 3
	XOR		DX, DX
	MOV		DL, DevicesInfo.ScreenWidth
	MOV		CL, 6
	SAL		DX, CL
	MOV		CX, 16
	SUB		DX, 48
	MOV		AX, 7
	INT		33H
	XOR		AX, AX
	MOV		AL, DevicesInfo.ScreenHeight
	MOV		DX, DevicesInfo.Vscan
	MUL		DX
	MOV		CL, 3
	SAL		AX, CL
	MOV		CX, 48
	SUB		AX, CX
	MOV		DX, AX
	MOV		AX, 8
	INT		33H
	POP		AX
	MOV		DX, DevicesInfo.Vscan
	MUL		DX
	XCHG	AX, DX
	POP		AX
	MOV		CL, 3
	SHL		AX, CL
	JMP		@2
{$ENDIF}
@1:	MOV		WORD PTR MouseDrawer, OFFSET DrawTextMouse
	MOV		AX, 15
	MOV		CX, 8
	MOV		DX, 16
	INT		33H
	XOR		DX, DX
	MOV		DL, DevicesInfo.ScreenWidth
	DEC		DX
	MOV		CL, 3
	SHL		DX, CL
	XOR		CX, CX
	MOV		AX, 7
	INT		33H
	XOR		DX, DX
	MOV		CL, 3
	MOV		DL, DevicesInfo.ScreenHeight
	DEC		DX
	SHL		DX, CL
	XOR		CX, CX
	MOV		AX, 8
	INT		33H
	POP		DX
	POP		AX
@2:	MOV		MouseX, AX
	MOV		MouseY, DX
	MOV		CL, 3
	SHL		DX, CL
	SHL		AX, CL
	XCHG	AX, CX
	MOV		AX, 4
	INT		33H
	MOV		AX, 28
	MOV		BX, 1
	INT		33H
	MOV		WORD PTR MouseDrawer [2], CS
	MOV		AX, 12
	MOV		CX, 1111B
	PUSH	CS
	POP		ES
	MOV		DX, OFFSET MouseInt
	INT		33H
	CALL	NormalMouse
	CALL	ShowMouse
{$IFDEF SupportMasterMouse}
	MOV		AL, AGraph
	MOV		Config.MouseGraph, AL
{$ENDIF}
@3:
end;

procedure NextMouseStage; far;
var
	P	: Pointer;
begin
	if PtrRec (MouseAnimator).Seg > 0 then
		begin
			P := MouseAnimator^.Next;
{$IFDEF SupportMasterMouse}
			if Config.MouseGraph then
				if P <> GraphMouseImage then
					GraphMouseImage := P
				else
					Exit
			else
{$ENDIF}
				if PtrRec (P).Ofs <> TextMouseImage then
					TextMouseImage := PtrRec (P).Ofs
				else
					Exit;
			RedrawMouse;
		end;
end;

procedure CheckMouseByTimer; far; assembler;
asm
	MOV		CX, MouseMark
	JCXZ	@2
	DEC		MouseMark
	JNE		@2
	CALL	NormalMouse
	JMP		@2
@1:	CALL	NextMouseStage
@2:	MOV		CX, WORD PTR TimerHandler
	JCXZ	@3
	CALL	[TimerHandler]
@3:
end;

{$L SYSINT}

const
	SCriticalError	: String [37] = '᪠ 訡   ᪥ %c:';
	SWriteProtected	: String [28] = '    ᪥ %c:';
	SDiskNotReady	: String [21] = '᪮ %c:  ⮢';
	SDataIntegrity	: String [25] = '訡   ᪥ %c:';
	SSeekError		: String [25] = '訡 ᪠  ᪥ %c:';
	SUnknownMedia	: String [36] = ' ⨯ ⥫  ᪥ %c:';
	SSectorNotFound	: String [28] = '    ᪥ %c:';
	SOutOfPaper		: String [21] = ' 㬠  ਭ';
	SWriteFault		: String [30] = '訡   ன⢥ %c:';
	SReadFault		: String [30] = '訡 ⥭  ன⢥ %c:';
	SGeneralFailure	: String [34] = '訡   ன⢥ %c:';
	SBadImageOfFAT	: String [28] = 'ᯮ祭  FAT  ';
	SDeviceError	: String [27] = '訡 㯠  ன';
	SInsertDisk		: String [27] = '⠢   ᪮ %c:';
	SRetryOrCancel	: String [37] = '~Enter~  , ~Esc~  ';

ErrorString: array[0..15] of Word = (
	Ofs (SWriteProtected),
	Ofs (SCriticalError),
	Ofs (SDiskNotReady),
	Ofs (SCriticalError),
	Ofs (SDataIntegrity),
	Ofs (SCriticalError),
	Ofs (SSeekError),
	Ofs (SUnknownMedia),
	Ofs (SSectorNotFound),
	Ofs (SOutOfPaper),
	Ofs (SWriteFault),
	Ofs (SReadFault),
	Ofs (SGeneralFailure),
	Ofs (SBadImageOfFAT),
	Ofs (SDeviceError),
	Ofs (SInsertDisk));

procedure InitSysError; external;
procedure DoneSysError; external;

procedure SwapStatusLine (var Buffer; From : Boolean); near; assembler;
asm
	CALL	HideMouse
	MOV		CL, DevicesInfo.ScreenWidth
	XOR		CH, CH
	MOV		AL, DevicesInfo.ScreenHeight
	DEC		AL
	MUL		CL
	SHL		AX, 1
	LES		DI, DevicesInfo.ScreenBuffer
	ADD		DI, AX
	MOV		CS:[OFFSET @S], SS
	MOV		CS:[OFFSET @P], SP
	MOV		AX, DS
	LDS		SI, Buffer
	MOV		SS, AX
	MOV		SP, OFFSET XlatScreen + 512
	TEST	From, -1
	JE		@2
	MOV		BX, OFFSET XlatScreen
@1:	MOV		AX, [SI]
	SEGSS	XLAT
	XCHG	ES:[DI], AX
	MOV		[SI], AX
	ADD		SI, 2
	ADD		DI, 2
	LOOP	@1
	JMP		@3
@S:	DW		0
@P:	DW		0
@2:	REP		MOVSW
@3:	MOV		AX, SS
	MOV		SS, CS:[OFFSET @S]
	MOV		SP, CS:[OFFSET @P]
	MOV		DS, AX
	CALL	ShowMouse
end;

function SelectKey : Integer; near; assembler;
asm
@1:	MOV		AH, 1
	INT		16H
	PUSHF
	MOV		AH, 0
	INT		16H
	POPF
	JNE		@1
	XOR		DX, DX
	CMP		AL, 13
	JE		@2
	INC		DX
	CMP		AL, 27
	JNE		@1
@2:	XCHG	DX, AX
end;

function SystemError (ErrorCode : Integer; Drive : Byte) : Integer;
var
	C	: Word;
	P	: Pointer;
	S	: String[63];
	B	: array[0..131] of Word;
begin
	if FailSysErrors then
		begin
			SystemError := 1;
			Exit;
		end;
	if Lo (DevicesInfo.ScreenMode) = smMono then
		C := SysMonoAttr
	else
		C := SysColorAttr;
	P := Pointer (Drive + Ord ('A'));
	FormatStr (S, PString (Ptr (DSeg, ErrorString [ErrorCode]))^, P);
	MoveChar (B, ' ', Lo (C), 131);
	MoveCStr (B [1], S, C);
	MoveCStr (B [79 - CStrLen (SRetryOrCancel)], SRetryOrCancel, C);
	SwapStatusLine (B, True);
	SystemError := SelectKey;
	SwapStatusLine (B, False);
end;

function ShiftStateHandler (AState : Word; As : Boolean) : Boolean; far;
var
	OldNew	: record
		New,
		Old	: Byte
	end absolute AState;

begin
	As := As and (OldNew.New < OldNew.Old);
	if As then
		ShiftStateCall := ShiftStateCall or OldNew.Old and not OldNew.New;
	ShiftStateHandler := not As;
end;

procedure ShowMouse; assembler;
asm
	INC		MouseVisible
	CMP		WORD PTR  MouseDrawer [2], 0
	JE		@1
	CALL	[MouseDrawer]
@1:
end;

procedure HideMouse; assembler;
asm
	DEC		MouseVisible
	CMP		WORD PTR  MouseDrawer [2], 0
	JE		@1
	CALL	[MouseDrawer]
@1:
end;

{$IFDEF UsePortTalk}
procedure Open_A000_Font;
const
	DoOpenA000	: array [0..20] of Byte =
	(ptCLI, ptBase, 0, 3,
		ptREPoutW, $C4, 2, 2, 4, 4, 7,
		ptREPoutW, $CE, 4, 5, 0, 6, 4, 4, 2,
	ptEND);
begin
	if not FontOpen then
		begin
			FontOpen := True;
			PortTalk (DoOpenA000);
		end;
end;

procedure Close_A000_Font;
const
	DoCloseA000	: array [0..21] of Byte =
	(ptBase, 0, 3,
		ptREPoutW, $C4, 2, 2, 3, 4, 3,
		ptREPoutW, $CE, 4, 5, 16, 6, 14, 4, 0, 4, 0,
	ptEND);
begin
	if FontOpen then
		begin
			FontOpen := False;
			if ScreenMode = 7 then
				Word (DoClose [19]) := $0806
			else
				Word (DoClose [19]) := $0004;
			PortTalk (DoCloseA000);
		end;
end;

{$ELSE}
procedure Open_A000_Font; assembler;
asm
	CLI
	CLD
	TEST	FontOpen, -1
	JNE		@3
	MOV		FontOpen, -1
	MOV		DX, 3C4H
	MOV		CX, 2
	CALL	@0
	DW		$0402, $0704, $0204, $0005, $0406
@0: POP		SI
@1:	SEGCS	LODSW
	OUT		DX, AX
	LOOP	@1
	MOV		DL, 0CEH
	MOV		CL, 3
@2:	SEGCS	LODSW
	OUT		DX, AX
	LOOP	@2
@3:
end;

procedure Close_A000_Font; assembler;
asm
	CLD
	TEST	FontOpen, -1
	JE		@3
	MOV		FontOpen, 0
	CLI
	MOV		DX, 3C4H
	MOV		CX, 2
	CALL	@0
	DW		$0302, $0304, $0004, $1005, $0E06, $0806
@0: POP		SI
@1:	SEGCS	LODSW
	OUT		DX, AX
	LOOP	@1
	MOV		DL, 0CEH
	MOV		CL, 3
	CMP		DevicesInfo.ScreenMode, 7
	JNE		@2
	INC		CX
@2:	SEGCS	LODSW
	OUT		DX, AX
	LOOP	@2
@3:
end;
{$ENDIF}

{********************************************************** TMouseAnimator **}
function TMouseAnimator.Next : Pointer;
begin
	Abstract;
end;
end.