{Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}

unit SmartDra;

interface

uses	Objects, Views;

{$I VERSION}

type

	TSmartBuffer = Object (TObject)
		procedure	Clear (AShift : Integer);
		procedure	Swap; virtual;
		procedure	Adjust; virtual;
		procedure	AddClip (Var S : String; Index, Count : Integer); virtual;
		procedure	AddChar (C : Char); virtual;
		procedure	RepeatChar (Count : Integer; C : Char); virtual;
		procedure	Pure (Count : Integer); virtual;
		function	Empty : Boolean;
	private
		Fill		: Integer;
		Shift		: Integer;
		_Shift		: Integer;
		Max			: Integer;
		procedure	FillFree; virtual;
	end;

	TSmartDraw = Object (TSmartBuffer)
		constructor Init (AMax : Byte; C : Word; CF : Byte);
		procedure	Swap; virtual;
		procedure	Adjust; virtual;
		procedure	AddClip (Var S : String; Index, Count : Integer); virtual;
		procedure	AddChar (C : Char); virtual;
		procedure	RepeatChar (Count : Integer; C : Char); virtual;
		procedure	Pure (Count : Integer); virtual;
		function	Draw : Pointer;
	private
		ColorN		: Byte;
		Colors		: Word;
		Safe1		: Word;
		Area1		: TDrawBuffer;
		Safe2		: Word;
		Area2		: TDrawBuffer;
		Store		: Word;
		V1, V2		: Word;
		procedure	FillFree; virtual;
	end;

	TTabText = Object (TSmartBuffer)
		constructor	Init (AMax : Integer);
		function	Text : String;
		procedure	AddChar (C : Char); virtual;
		procedure	Write (Var S : TStream);
		procedure	Pure (Count : Integer); virtual;
		function	Ptr : Pointer;
		function	Length : Word;
		procedure	Adjust; virtual;
		procedure	Swap; virtual;
		procedure	RepeatChar (Count : Integer; C : Char); virtual;
		procedure   AddClip (Var S : String; Index, Count : Integer); virtual;
		destructor	Done; virtual;
	private
		Buffer		: Pointer;
		B2			: Pointer;
		Store		: Pointer;
		procedure	FillFree; virtual;
	end;

	TTabLine = Object (TTabText)
		constructor	Init (AMax : Integer);
		destructor	Done; virtual;
	private
		Area1	: array [0..256] of Byte;
		Area2	: array [0..256] of Byte;
	end;

implementation

{************************************************************ TSmartBuffer **}
procedure TSmartBuffer.Clear (AShift : Integer);
begin
	Shift := AShift;
	_Shift := AShift;
	Fill := Max;
	FillFree;
end;

procedure TSmartBuffer.Swap;
begin
end;

procedure TSmartBuffer.Adjust;
begin
end;

procedure TSmartBuffer.AddClip;
begin
end;

procedure TSmartBuffer.AddChar;
begin
end;

procedure TSmartBuffer.RepeatChar;
begin
end;

procedure TSmartBuffer.Pure;
begin
end;

function TSmartBuffer.Empty : Boolean; assembler;
asm
	LES		DI, Self
	XOR		AX, AX
	CMP		AX, ES:[DI].Fill
	JGE		@1
	INC		AX
@1:
end;

procedure TSmartBuffer.FillFree;
begin
end;

{************************************************************** TSmartDraw **}
constructor TSmartDraw.Init (AMax : Byte; C : Word; CF : Byte);
begin
	Colors := C;
	ColorN := CF;
	if AMax > MaxViewWidth then AMax := MaxViewWidth;
	Max := AMax;
	Fill := 0;
	asm
		LES		SI, Self
		LEA		DI, [SI].Area1
		MOV		ES:[SI].V1, DI
		LEA		DI, [SI].Area2
		MOV		ES:[SI].V2, DI
		MOV		CX, ES:[SI].Max
		CLD
		XOR		AX, AX
		REP		STOSW
	end;
end;

procedure TSmartDraw.FillFree; assembler;
asm
	LES		SI, Self
	MOV		DI, ES:[SI].V1
	MOV		ES:[SI].Store, DI
	MOV		WORD PTR ES:[DI - 2], 0
end;

function TSmartDraw.Draw : Pointer; assembler;
asm
	LES		DI, Self
	MOV		BX, ES:[DI].V1
	MOV		CX, ES:[DI].Max
	MOV		AH, BYTE PTR ES:[DI].ColorN
	MOV		DI, ES:[DI].Store
	ADD		CX, CX
	ADD		CX, BX
	SUB		CX, DI
	JLE		@1
	CLD
	SHR		CX, 1
	MOV		AL, ' '
	REP		STOSW
@1:	MOV		DX, ES
	MOV		AX, BX
end;

procedure TSmartDraw.Swap; assembler;
asm
	LES		DI, Self
	MOV		AX, ES:[DI].V1
	XCHG	AX, ES:[DI].V2
	MOV		ES:[DI].V1, AX
	PUSH	ES:[DI]._Shift
	PUSH	ES
	PUSH	DI
	CALL	Clear
end;

procedure TSmartDraw.Pure (Count : Integer); assembler;
asm
	LES		SI, Self
	MOV		AX, Count
	MOV		BX, ES:[SI].Shift
	OR		BX, BX
	JS		@1
	SUB		ES:[SI].Shift, AX
	SUB		AX, BX
	JLE		@2
@1:	MOV		BX, ES:[SI].Fill
	OR		BX, BX
	JS		@2
	SUB		BX, AX
	JG		@3
	ADD		AX, BX
	MOV		BX, -1
@3:	MOV		ES:[SI].Fill, BX
	MOV		CX, AX
	MOV		DI, ES:[SI].Store
	CLD
	MOV		AL, ' '
	MOV		AH, BYTE PTR ES:[SI].Colors
	REP		STOSW
	MOV		ES:[SI].Store, DI
@2:
end;

procedure TSmartDraw.AddChar (C : Char); assembler;
asm
	MOV		DX, DS
	LDS		SI, Self
	MOV		AL, C
	CMP		AL, '~'
	JE		@2
	DEC		[SI].Shift
	JNS		@3
	DEC		[SI].Fill
	JS		@3
	MOV		DI, [SI].Store
	CMP		AL, ''
	JNE		@1
	MOV		AH, [DI - 2]
	CMP		AH, ''
	JB		@1
	CMP		AH, ''
	JA		@1
	MOV		AL, ''
@1: MOV		AH, BYTE PTR [SI].Colors
	MOV		[DI], AX
	INC		DI
	INC		DI
	MOV		[SI].Store, DI
	JMP		@3
@2:	MOV		AX, [SI].Colors
	XCHG	AL, AH
	MOV		[SI].Colors, AX
@3:	MOV		DS, DX
end;

procedure TSmartDraw.Adjust; assembler;
asm
	MOV		DX, DS
	LDS		DI, Self
	MOV		SI, [DI].V2
	MOV		CX, [DI].Store
	MOV		DI, [DI].V1
	SUB		CX, DI
	SHR		CX, 1
	JCXZ	@5
	CLD
@1:	MOV		AH, [DI]
	LODSB
	INC		SI
	CMP		AL, ''
	JB		@4
	JE		@2
	CMP		AL, ''
	JA		@4
	CMP		AL, ''
	JE		@2
	CMP		AL, ''
	JE		@2
	CMP		AL, ''
	JE		@2
	CMP		AL, ''
	JE		@2
	CMP		AL, ''
	JNE		@4
@2:	MOV		AL, ''
	CMP		AH, ''
	JB		@4
	JE		@3
	MOV		AL, ''
	CMP		AH, ''
	JA		@4
	JE		@3
	MOV		AL, ''
	CMP		AH, ''
	JE		@3
	MOV		AL, ''
	CMP		AH, ''
	JNE		@4
@3:	MOV		[DI], AL
@4:	INC		DI
	INC		DI
	LOOP	@1
@5:	MOV		DS, DX
end;

procedure TSmartDraw.AddClip (Var S : String; Index, Count : Integer); assembler;
asm
	MOV		DX, DS
	CLD
	LDS		SI, S
	LES		DI, Self
	LODSB
	MOV		AH, 0
	ADD		SI, Index
	SUB		AX, Index
	JBE		@4
	CMP		AX, Count
	JB		@6
	MOV		AX, Count
@6:	MOV		BX, ES:[DI].Shift
	OR		BX, BX
	JS		@1
	SUB		AX, BX
	JBE		@3
	ADD		SI, BX
	MOV		ES:[DI].Shift, -1
@1:	MOV		BX, ES:[DI].Fill
	OR		BX, BX
	JS		@4
	SUB		BX, AX
	JG		@2
	ADD		AX, BX
	MOV		BX, -1
@2: MOV		ES:[DI].Fill, BX
	MOV		CX, AX
	MOV		AH, BYTE PTR ES:[DI].Colors
	MOV		DI, ES:[DI].Store
	CMP		BYTE [SI], ''
	JNE		@0
	MOV		BH, ES:[DI - 2]
	CMP		BH, ''
	JB		@0
	MOV		AL, ''
	JE		@5
	CMP		BH, ''
	JA		@0
	MOV		AL, ''
	JE		@5
	MOV		AL, ''
	CMP		BH, ''
	JE		@5
	MOV		AL, ''
	CMP		BH, ''
	JNE		@0
@5:	MOV		ES:[DI - 2], AL
@0:	LODSB
	STOSW
	LOOP	@0
	LES		SI, Self
	MOV		ES:[SI].Store, DI
	JMP		@4
@3:	NEG		AX
	MOV		ES:[DI].Shift, AX
@4:	MOV		DS, DX
end;

procedure TSmartDraw.RepeatChar (Count : Integer; C : Char); assembler;
asm
	CLD
	LES		DI, Self
	MOV		AX, Count
	MOV		BX, ES:[DI].Shift
	OR		BX, BX
	JS		@1
	SUB		AX, BX
	JBE		@3
	MOV		ES:[DI].Shift, -1
@1:	MOV		BX, ES:[DI].Fill
	OR		BX, BX
	JS		@4
	SUB		BX, AX
	JG		@2
	ADD		AX, BX
	MOV		BX, -1
@2: MOV		ES:[DI].Fill, BX
	MOV		CX, AX
	MOV		AH, BYTE PTR ES:[DI].Colors
	MOV		DI, ES:[DI].Store
	MOV		AL, C
	CMP		AL, ''
	JNE		@0
	MOV		BH, ES:[DI - 2]
	CMP		BH, ''
	JB		@0
	MOV		BL, ''
	JE		@5
	CMP		BH, ''
	JA		@0
	MOV		BL, ''
	JE		@5
	MOV		BL, ''
	CMP		BH, ''
	JE		@5
	MOV		BL, ''
	CMP		BH, ''
	JNE		@0
@5:	MOV		ES:[DI-2], BL
@0:	REP		STOSW
	LES		SI, Self
	MOV		ES:[SI].Store, DI
	JMP		@4
@3:	NEG		AX
	MOV		ES:[DI].Shift, AX
@4:
end;

{**************************************************************** TTabText **}
constructor	TTabText.Init (AMax : Integer);
begin
	TObject.Init;
	GetMem (Buffer, AMax + 1);
	GetMem (B2, AMax + 1);
	Max := AMax;
	Max := AMax;
	Fill := 0;
	asm
		LES		DI, Self
		MOV		CX, ES:[DI].Max
		LES		DI, ES:[DI].B2
		CLD
		XOR		AX, AX
		REP		STOSB
	end;
end;

procedure TTabText.FillFree; assembler;
asm
	LES		SI, Self
	MOV		AX, WORD PTR ES:[SI].Buffer + 2
	MOV		DI, WORD PTR ES:[SI].Buffer
	INC		DI
	MOV		WORD PTR ES:[SI].Store, DI
	MOV		WORD PTR ES:[SI].Store + 2, AX
	MOV		ES, AX
	MOV		WORD PTR ES:[DI - 1], 0
end;

procedure TTabText.Swap; assembler;
asm
	LES		DI, Self
	MOV		AX, WORD PTR ES:[DI].Buffer
	MOV		DX, WORD PTR ES:[DI].Buffer + 2
	XCHG	AX, WORD PTR ES:[DI].B2
	XCHG	DX, WORD PTR ES:[DI].B2 + 2
	MOV		WORD PTR ES:[DI].Buffer, AX
	MOV		WORD PTR ES:[DI].Buffer + 2, DX
	PUSH	ES:[DI]._Shift
	PUSH	ES
	PUSH	DI
	CALL	Clear
end;

procedure TTabText.AddChar (C : Char); assembler;
asm
	MOV		DX, DS
	LDS		SI, Self
	MOV		AL, C
	DEC		[SI].Shift
	JNS		@3
	DEC		[SI].Fill
	JS		@3
	LES		DI, [SI].Store
	CMP		AL, ''
	JNE		@1
	MOV		AH, [DI - 1]
	CMP		AH, ''
	JB		@1
	CMP		AH, ''
	JA		@1
	MOV		AL, ''
@1: CLD
	STOSB
	MOV		WORD PTR [SI].Store, DI
@3:	MOV		DS, DX
end;

procedure TTabText.AddClip (Var S : String; Index, Count : Integer); assembler;
asm
	MOV		DX, DS
	CLD
	LDS		SI, S
	LES		DI, Self
	LODSB
	MOV		AH, 0
	ADD		SI, Index
	SUB		AX, Index
	JBE		@4
	CMP		AX, Count
	JB		@6
	MOV		AX, Count
@6:	MOV		BX, ES:[DI].Shift
	OR		BX, BX
	JS		@1
	SUB		AX, BX
	JBE		@3
	ADD		SI, BX
	MOV		ES:[DI].Shift, -1
@1:	MOV		BX, ES:[DI].Fill
	OR		BX, BX
	JS		@4
	SUB		BX, AX
	JG		@2
	ADD		AX, BX
	MOV		BX, -1
@2: MOV		ES:[DI].Fill, BX
	MOV		CX, AX
	LES		DI, ES:[DI].Store
	CMP		BYTE [SI], ''
	JNE		@0
	MOV		BH, ES:[DI - 1]
	CMP		BH, ''
	JB		@0
	MOV		AL, ''
	JE		@5
	CMP		BH, ''
	JA		@0
	MOV		AL, ''
	JE		@5
	MOV		AL, ''
	CMP		BH, ''
	JE		@5
	MOV		AL, ''
	CMP		BH, ''
	JNE		@0
@5:	MOV		ES:[DI - 1], AL
@0:	REP		MOVSB
	LES		SI, Self
	MOV		WORD PTR ES:[SI].Store, DI
	JMP		@4
@3:	NEG		AX
	MOV		ES:[DI].Shift, AX
@4:	MOV		DS, DX
end;

procedure TTabText.RepeatChar (Count : Integer; C : Char); assembler;
asm
	CLD
	LES		DI, Self
	MOV		AX, Count
	MOV		BX, ES:[DI].Shift
	OR		BX, BX
	JS		@1
	SUB		AX, BX
	JBE		@3
	MOV		ES:[DI].Shift, -1
@1:	MOV		BX, ES:[DI].Fill
	OR		BX, BX
	JS		@4
	SUB		BX, AX
	JG		@2
	ADD		AX, BX
	MOV		BX, -1
@2: MOV		ES:[DI].Fill, BX
	MOV		CX, AX
	LES		DI, ES:[DI].Store
	MOV		AL, C
	CMP		AL, ''
	JNE		@0
	MOV		BH, ES:[DI - 1]
	CMP		BH, ''
	JB		@0
	MOV		BL, ''
	JE		@5
	CMP		BH, ''
	JA		@0
	MOV		BL, ''
	JE		@5
	MOV		BL, ''
	CMP		BH, ''
	JE		@5
	MOV		BL, ''
	CMP		BH, ''
	JNE		@0
@5:	MOV		ES:[DI-1], BL
@0:	REP		STOSB
	LES		SI, Self
	MOV		WORD PTR ES:[SI].Store, DI
	JMP		@4
@3:	NEG		AX
	MOV		ES:[DI].Shift, AX
@4:
end;

procedure TTabText.Pure (Count : Integer); assembler;
asm
	MOV		DX, DS
	LDS		SI, Self
	MOV		AX, Count
	MOV		BX, [SI].Shift
	OR		BX, BX
	JS		@1
	SUB		[SI].Shift, AX
	SUB		AX, BX
	JLE		@2
@1:	MOV		BX, [SI].Fill
	OR		BX, BX
	JS		@2
	SUB		BX, AX
	JG		@3
	ADD		AX, BX
	MOV		BX, -1
@3:	MOV		[SI].Fill, BX
	MOV		CX, AX
	LES		DI, [SI].Store
	CLD
	MOV		AL, ' '
	REP		STOSB
	MOV		WORD PTR [SI].Store, DI
@2:	MOV		DS, DX
end;

function TTabText.Text : String; assembler;
asm
	MOV		DX, DS
	CLD
	LES		DI, @Result
	INC		DI
	LDS		SI, Self
	MOV		CX, WORD PTR [SI].Store
	LDS		SI, [SI].Buffer
	INC		SI
	SUB		CX, SI
	REP		MOVSB
	MOV		AX, WORD PTR @Result
	XCHG	AX, DI
	SUB		AX, DI
	DEC		AX
	STOSB
	MOV		DS, DX
end;

function TTabText.Ptr : Pointer; assembler;
asm
	LES		DI, Self
	MOV		AX, WORD PTR ES:[DI].Buffer
	MOV		DX, WORD PTR ES:[DI].Buffer + 2
	INC		AX
end;

function TTabText.Length : Word; assembler;
asm
	LES		DI, Self
	MOV		AX, WORD PTR ES:[DI].Store
	SUB		AX, WORD PTR ES:[DI].Buffer
	DEC		AX
end;

procedure TTabText.Adjust; assembler;
asm
	MOV		DX, DS
	LES		DI, Self
	LDS		SI, ES:[DI].B2
	MOV		CX, WORD PTR ES:[DI].Store
	LES		DI, ES:[DI].Buffer
	INC		DI
	INC		SI
	SUB		CX, DI
	JCXZ	@2
	CLD
@1:	MOV		AH, ES:[DI]
	LODSB
	CMP		AL, ''
	JB		@4
	JE		@2
	CMP		AL, ''
	JA		@4
	CMP		AL, ''
	JE		@2
	CMP		AL, ''
	JE		@2
	CMP		AL, ''
	JE		@2
	CMP		AL, ''
	JE		@2
	CMP		AL, ''
	JNE		@4
@2:	MOV		AL, ''
	CMP		AH, ''
	JB		@4
	JE		@3
	MOV		AL, ''
	CMP		AH, ''
	JA		@4
	JE		@3
	MOV		AL, ''
	CMP		AH, ''
	JE		@3
	MOV		AL, ''
	CMP		AH, ''
	JNE		@4
@3:	MOV		ES:[DI], AL
@4:	INC		DI
@5:	LOOP	@1
	MOV		DS, DX
end;

procedure TTabText.Write (Var S : TStream);
begin
	S.Write (Buffer^, PtrRec (Store).Ofs - PtrRec (Buffer).Ofs);
end;

destructor TTabText.Done;
begin
	if PtrRec (Buffer).Seg > 0 then FreeMem (Buffer, Max);
	if PtrRec (B2).Seg > 0 then FreeMem (B2, Max);
	TObject.Init;
end;

constructor TTabLine.Init (AMax : Integer);
begin
	TObject.Init;
	Buffer := @Area1;
	B2 := @Area2;
	if AMax > 256 then AMax := 256;
	Max := AMax;
end;

destructor TTabLine.Done;
begin
	TObject.Init;
end;

end.