;1/2 Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su

	TITLE	SYSINT

	LOCALS

; Keyboard scan codes

scSpaceKey	EQU	39H
scInsKey	EQU	52H
scDelKey	EQU	53H
scUpKey		EQU	48H
scDownKey	EQU	50H
scUp101		EQU	75H
scDown101	EQU	72H
scCenterKey	EQU	4CH
scBackKey	EQU	0EH
scEnterKey	EQU	1CH
scEscKey	EQU	01H
scTabKey	EQU	0FH
scMinusKey	EQU	0CH
scEqualKey	EQU	0DH
scSlagKey	EQU	2BH
scQuestKey	EQU	35H

; Keyboard shift flags

kbShiftKey	EQU	03H
kbCtrlKey	EQU	04H
kbAltKey	EQU	08H

; ROM BIOS workspace

KeyFlags	EQU	(BYTE PTR 17H)
KeyBufHead	EQU	(WORD PTR 1AH)
KeyBufTail	EQU	(WORD PTR 1CH)
KeyBufOrg	EQU	(WORD PTR 1EH)
KeyBufEnd	EQU	(WORD PTR 3EH)

; Data segment

_DATA		SEGMENT WORD PUBLIC 'DATA'

; Externals

	EXTRN	SysErrorFunc:DWORD
	EXTRN	CtrlBreakHit:BYTE
	EXTRN	SaveCtrlBreak:BYTE
	EXTRN	SysErrActive:BYTE
	EXTRN	ShiftStateHandler:FAR
	EXTRN	CheckMouseByTimer:FAR;

_DATA		ENDS

; Data group

DGROUP		GROUP	_DATA

; Code segment

SYSINT_TEXT	SEGMENT	BYTE PUBLIC 'CODE'

	ASSUME	CS:SYSINT_TEXT, DS:DGROUP

	PUBLIC	InitSysError
	PUBLIC	DoneSysError

; CS - based variables

SaveInt1C	DD	0	;Saved INT 1CH vector
SaveInt09	DD	0	;Saved INT 09H vector
SaveInt1B	DD	0	;Saved INT 1BH vector
SaveInt23	DD	0	;Saved INT 23H vector
SaveInt24	DD	0	;Saved INT 24H vector

; Keyboard conversion table

KeyConvertTab	LABEL	BYTE

	DB	scSpaceKey, kbAltKey
	DW	0200H
	DB	scInsKey, kbCtrlKey
	DW	9200H
	DB	scInsKey, kbShiftKey
	DW	0D200H
	DB	scInsKey, KbAltKey
	DW	0100H
	DB	scDelKey, kbCtrlKey
	DW	9300H
	DB	scDelKey, kbShiftKey
	DW	0D300H
	DB	scDelKey, kbAltKey
	DW	0A300H
	DB	scUpKey, kbCtrlKey
	DW	8D00H
	DB	scDownKey, kbCtrlKey
	DW	9100H
	DB	scUp101, kbCtrlKey
	DW	8D00H
	DB	scDown101, kbCtrlKey
	DW	9100H
	DB	scCenterKey, kbCtrlKey
	DW	8F00H
	DB	scBackKey, kbAltKey
	DW	0EH
	DB	scEnterKey, kbAltKey
	DW	1CH

KeyConvertCnt	EQU	($ - KeyConvertTab) / 4

; Install system error handlers

InitSysError:
	MOV	AX, 3300H
	INT	21H
	MOV	SaveCtrlBreak, DL
	MOV	AX, 3301H
	MOV	DL, 0
	INT	21H
	PUSH	DS
	PUSH	CS
	POP	DS
	MOV	AX, 351BH
	INT	21H
	MOV	WORD PTR SaveInt1B, BX
	MOV	WORD PTR SaveInt1B + 2, ES
	MOV	AL, 1CH
	INT	21H
	MOV	WORD PTR SaveInt1C, BX
	MOV	WORD PTR SaveInt1C + 2, ES
	MOV	AL, 23H
	INT	21H
	MOV	WORD PTR SaveInt23, BX
	MOV	WORD PTR SaveInt23 + 2, ES
	INC	AL
	INT	21H
	MOV	WORD PTR SaveInt24, BX
	MOV	WORD PTR SaveInt24 + 2, ES
	MOV	AL, 09H
	INT	21H
	MOV	WORD PTR SaveInt09, BX
	MOV	WORD PTR SaveInt09 + 2, ES
	MOV	AH, 25H
	SUB	BX, 4
	JC	@@1
	CMP	WORD PTR ES: [BX], 'DT'
	JNE	@@1
	CMP	WORD PTR ES: [BX + 2], '9I'
	JE	@@2
@@1:	MOV	DX, OFFSET Int09Handler
	INT	21H
@@2:	MOV	AL, 1BH
	MOV	DX, OFFSET Int1BHandler
	INT	21H
	MOV	AL, 1CH
	MOV	DX, OFFSET Int1CHandler
	INT	21H
	MOV	AL, 23H
	MOV	DX, OFFSET Int23Handler
	INT	21H
	INC	AL
	MOV	DX, OFFSET Int24Handler
	INT	21H
	POP	DS
	MOV	SysErrActive, 1
	RETF

; Remove system error handlers

DoneSysError:
	CMP	SysErrActive, 0
	JE	@@1
	MOV	SysErrActive, 0
	PUSH	DS
	MOV	AX, 2509H
	LDS	DX, CS:SaveInt09
	INT	21H
	MOV	AL, 1BH
	LDS	DX, CS:SaveInt1B
	INT	21H
	MOV	AL, 1CH
	LDS	DX, CS:SaveInt1C
	INT	21H
	MOV	AL, 23H
	LDS	DX, CS:SaveInt23
	INT	21H
	INC	AL
	LDS	DX, CS:SaveInt24
	INT	21H
	POP	DS
	MOV	AX, 3301H
	MOV	DL, SaveCtrlBreak
	INT	21H
@@1:	RETF

; INT 09H handler signature

	DB	'CyrVis2 TVI9'

; INT 09H handler

Int09Handler:
	PUSH	DS
	PUSH	DI
	PUSH	AX
	MOV	AX, 40H
	MOV	DS, AX
	MOV	DI, DS:KeyBufTail
	IN	AL, 60H
	MOV	AH, DS:KeyFlags
	PUSHF
	CALL	SaveInt09
	PUSH	SI
	PUSH	CX
	TEST	AL, 80H
	JNE	@@9
	MOV	SI, OFFSET CS:KeyConvertTab
	MOV	CX, KeyConvertCnt
@@1:	CMP	AL, CS:[SI]
	JNE	@@2
	TEST	AH, CS:[SI + 1]
	JNE	@@3
@@2:	ADD	SI, 4
	LOOP	@@1
@@9:	CMP	DI, DS:KeyBufTail
	JNE	@@8
	MOV	AL, DS:KeyFlags
	CMP	AH, AL
	JE	SHORT @@A
	PUSH	ES
	PUSH	DX
	PUSH	BX
	PUSH	BP
	PUSH	AX
	MOV	AL, @@F
	PUSH	AX
	MOV	AX, SEG DGROUP
	MOV	DS, AX
	CALL	ShiftStateHandler
	POP	BP
	POP	BX
	POP	DX
	POP	ES
	MOV	@@F, AL
	JMP	SHORT @@A
@@F	DB      0
@@3:	CMP	DI, DS:KeyBufTail
	JNE	@@5
	MOV	AX, DI
	INC	AX
	INC	AX
	CMP	AX, OFFSET KeyBufEnd
	JNE	@@4
	MOV	AX, OFFSET KeyBufOrg
@@4:	CMP	AX, DS:KeyBufHead
	JE	@@8
	MOV	DS:KeyBufTail, AX
	MOV	DI, AX
@@5:	MOV	AX, CS:[SI + 2]
	MOV	DS:[DI], AX
@@8:    MOV	@@F, 0
@@A:	POP	CX
	POP	SI
	POP	AX
	POP	DI
	POP	DS
	IRET

; INT 1CH handler

Int1CHandler:

	PUSH	DS
	PUSH	AX
	MOV	AX, SEG DGROUP
	MOV	DS, AX
	PUSH	CX
	PUSH	BX
	PUSH	DX
	PUSH	ES
	PUSH	SI
	PUSH	DI
	PUSH	BP
	CALL	CheckMouseByTimer
	POP	BP
	POP	DI
	POP SI
	POP ES
	POP DX
	POP BX
	POP CX
	POP AX
	POP	DS
	JMP	[SaveInt1C]

; INT 1BH handler

Int1BHandler:

	PUSH	DS
	PUSH	AX
	XOR	AX, AX
	MOV	DS, AX
	AND	BYTE PTR DS:[471H], 7FH
	MOV	AX, SEG DGROUP
	MOV	DS, AX
	MOV	CtrlBreakHit, 1
	POP	AX
	POP	DS

Int23Handler:
	IRET

Int24Handler:
	STI				;Enable interrupts
	PUSH	ES			;Save registers
	PUSH	DS
	PUSH	BP
	PUSH	DI
	PUSH	SI
	PUSH	DX
	PUSH	CX
	PUSH	BX
	AND	DI, 0FFH		;Error code in low byte
	PUSH	DI			;Save error code
	CMP	DI, 9			;Printer out of paper
	JE	@@0			;Yes, @@0
	TEST	AH, 80H			;Disk error?
	JE	@@1			;Yes, @@1
	MOV	DI, 13			;Bad memory image of FAT
	MOV	DS, BP			;Point DS:SI to device header
	TEST	BYTE PTR DS:[SI + 5], 80H	;Block device?
	JE	@@1			;Yes, @@0
	INC	DI			;Device access error
@@0:	MOV	AL, 0FFH			;No drive code
@@1:	MOV	DX, SEG DGROUP		;Setup DS
	MOV	DS, DX
	PUSH	DI			;Push error code
	PUSH	AX			;Push drive code
	CALL	SysErrorFunc		;Call system error handler
	POP	DI			;Restore error code
	OR	AX, AX			;Zero if retry
	MOV	AX, 1			;Retry return code
	JE	@@3			;Jump if retry
	ADD	SP, (8 + 3) * 2		;Remove saved regs and INT
	POP	AX			;Get INT 21H AX register
	ADD	DI, 19			;Return AX = 19..31
	CMP	AH, 39H			;DOS 2.0 style function?
	JAE	@@2			;Yes, @@1
	MOV	DI, 0FFFFH		;Return AX = 0FFFFH
@@2:	MOV	AH, 54H			;Dummy function call to get
	INT	21H			;DOS into a stable state
	MOV	AX, DI			;Get return code
	MOV	BP, SP			;Set CF in return flags
	OR	BYTE PTR [BP + 20], 1
@@3:	POP	BX			;Restore registers
	POP	CX
	POP	DX
	POP	SI
	POP	DI
	POP	BP
	POP	DS
	POP	ES
	IRET

SYSINT_TEXT	ENDS

	END
