{Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}
{$D+}

unit SysVars;

interface

{$I VERSION}


{ TPortTalksItems }
	ptBASE		= 0;
	ptIN		= 1;
	ptInW		= 2;
	ptOUT		= 3;
	ptOutW		= 4;
	ptREPOUT	= 5;
	ptREPoutW	= 6;
	ptCLI		= 7;
	ptSTI		= 8;
	ptSTORE		= 9;
	ptStoreW	= 10;
	ptEND		= 11;

const
	Seg0000		: Word = $0000;
	Seg0040		: Word = $0040;
	SegBIOS		: Word = $F000;
	SegB000		: Word = $B000;
	SegB800		: Word = $B800;
	SegA000		: Word = $A000;

{$IFDEF Protected}
function SystemType : Byte;
function Equipment : Word;
function Timer : Longint;
function TimerLow : Word;
function CrtInfo : Byte;
function CrtRows : Byte;
function KeyBoardFlags : Word;
function ShiftState : Byte;
{$ELSE}
var
	SystemType		: Byte absolute		$F000:$FFFE;
	Equipment		: Word absolute		$0040:$0010;
	Timer			: Longint absolute	$0040:$006C;
	TimerLow		: Word absolute		$0040:$006C;
	CrtInfo			: Byte absolute		$0040:$0087;
	CrtRows			: Byte absolute		$0040:$0084;
	KeyBoardFlags	: Word absolute		$0040:$0017;
	ShiftState		: Byte absolute		$0040:$0017;
{$ENDIF}

function BIOSdate : String;
function ShiftPressed : Boolean;
function AltPressed : Boolean;
function CtrlPressed : Boolean;
function KeyBoardExtended : Boolean;
procedure Sleep (I : Integer);
function GetShiftState : Byte;
inline (
	$33/$C0/	{	XOR		AX, AX	}
	$CD/$16		{	INT		16H		}
	);

procedure BrkPoint;
inline ($CC);

function PortTalk (Var ATalk) : Word;
procedure ReBoot;

implementation

function ShiftPressed : Boolean; assembler;
asm
	MOV		AH, 2
	INT		16H
	XCHG	AH, AL
	MOV		AL, 1
	TEST	AH, 3
	JNE		@1
	DEC		AL
@1:
end;

function CtrlPressed : Boolean; assembler;
asm
	MOV		AH, 2
	INT		16H
	XCHG	AH, AL
	MOV		AL, 1
	TEST	AH, 4
	JNE		@1
	DEC		AL
@1:
end;

function AltPressed : Boolean; assembler;
asm
	MOV		AH, 2
	INT		16H
	XCHG	AH, AL
	MOV		AL, 1
	TEST	AH, 8
	JNE		@1
	DEC		AL
@1:
end;

function KeyBoardExtended : Boolean; assembler;
asm
	MOV		AH, 2
	INT		16H
	NOT		AL
	MOV		BL, AL
	MOV		AH, 12
	INT		16H
	CMP		AL, BL
	JNE		@1
	MOV		AL, 1
	JMP		@2
@1:	MOV		AL, 0
@2:
end;

procedure ReBoot; assembler;
asm
	MOV		AH, 0DH
	INT		21H
	MOV		DS, Seg0040
	MOV		WORD PTR DS:[0072H], 1234H
	DB		0EAH
	DW		0, -1
end;

function PortTalk (Var ATalk) : Word; assembler;
asm
	XOR		CX, CX
	PUSH	DS
	CLD
	LDS		SI, ATalk
@1: XCHG	AX, BX
	XOR		AX, AX
	LODSB
	CMP		AL, ptEND
	XCHG	AX, BX
	JAE		@5
	ADD		BX, BX
	XOR		DX, DX
	MOV		DL, [SI]
	INC		SI
	ADD		DX, DI
	CALL	WORD PTR CS:[BX + OFFSET @2]
	JMP		@1
@2:	DW		OFFSET @B
	DW		OFFSET @I
	DW		OFFSET @IW
	DW		OFFSET @O
	DW		OFFSET @OW
	DW		OFFSET @R
	DW		OFFSET @RW
	DW		OFFSET @C
	DW		OFFSET @S
	DW		OFFSET @E
@B:	MOV		DI, [SI - 1]
	INC		SI
	RETN
@I: MOV		AH, AL
	IN		AL, DX
	RETN
@IW:IN		AX, DX
	RETN
@O: LODSB
	OUT		DX, AL
	RETN
@OW:LODSW
	OUT		DX, AX
	RETN
@R:	MOV		CL, [SI]
	INC		SI
@3:	LODSB
	OUT		DX, AL
	LOOP	@3
	RETN
@RW:MOV		CL, [SI]
	INC		SI
@4:	LODSW
	OUT		DX, AX
	LOOP	@4
	RETN
@C:	CLI
	DEC		SI
	RETN
@S:	STI
	DEC		SI
	RETN
@E:	MOV		[SI - 1], AL
	RETN
@EW:MOV		[SI - 1], AX
	INC		SI
	RETN
@5:	POP		DS
end;

procedure Sleep (I : Integer); assembler;
asm
	MOV		ES, Seg0040
	MOV		AX, WORD PTR ES:Timer
	ADD		AX, I
	JC		@2
@1:	CMP		AX, WORD PTR ES:Timer
	JA		@1
	JMP		@3
@2:	CMP		AX, WORD PTR ES:Timer
	JB		@1
@3:
end;

function BIOSdate : String; assembler;
asm
	LES		DI, @Result
	CLD
	MOV		AX, 8
	STOSB
	PUSH	DS
	MOV		DS, SegBIOS
	MOV		SI, 0FFF5H
	XCHG	AX, CX
	REP		MOVSB
	POP		DS
end;

{$IFDEF Protected}

function SystemType : Byte; assembler;
asm
	MOV		ES, SegBIOS
	MOV		AL, ES:[0FFFEH]
end;

function Equipment : Word; assembler;
asm
	MOV		ES, Seg0040
	MOV		AX, ES:[0010H]
end;

function Timer : Longint; assembler;
asm
	MOV		ES, Seg0040
	MOV		AX, ES:[006CH]
	MOV		DX, ES:[006EH]
end;

function TimerLow : Word; assembler;
asm
	MOV		ES, Seg0040
	MOV		AX, ES:[006CH]
end;

function CrtInfo : Byte; assembler;
asm
	MOV		ES, Seg0040
	MOV		AL, ES:[0087H]
end;

function CrtRows : Byte; assembler;
asm
	MOV		ES, Seg0040
	MOV		AL, ES:[0084H]
end;

function KeyBoardFlags : Word; assembler;
asm
	MOV		ES, Seg0040
	MOV		AX, ES:[0017H]
end;

function ShiftState : Byte; assembler;
asm
	MOV		ES, Seg0040
	MOV		AL, ES:[0017H]
end;
{$ENDIF}

end.